//(- dsRE code
#include "dni.h"
#include "GlobalFunc.h"

RuntimeVars_t g_RuntimeVars={0,0,0};
HMODULE dvm_dll=NULL;
dbool (_stdcall *CreateVM)(dVM **vm);
void (__stdcall *ReleaseVM)(dVM *vm);

dobject CreateObjectByInstance(dFactory *factory,dchararray cls_name,void *local_inst);
dobject dcall FindClass
  (dFactory *factory,dchararray name)
{
  dobject dobj=factory->IsClass(name);
  if(dobj==NULL)
  {
    dobj=CreateObjectByInstance(factory,name,NULL);
    if(dobj)
      factory->AddClass(name,dobj);
  }
  if(dobj)//sure vcl class
  {
  }
  return dobj;
}
dobject dcall WrapExistsInstance
  (dFactory *factory,dchararray cls_name,void *local_object)
{
  if(local_object)
  {
      dobject dobj=CreateObjectByInstance(factory,cls_name,local_object);
    if(dobj)
    {
      dobj->flags|=OF_CREATE_SUCCESS;

      dAutoArg args;
      dValue ret;
      dValue temp;
      args<<&temp<<&temp<<&temp<<&temp;
      dobj->Invoke((dobject)factory,L"_Constructor",&args,&ret);

      dobj->flags|=OF_CONSTRUCT_SUCCESS;
    }
    return dobj;
  }
  return NULL;
}

extern "C"
int SimpleCreate_dvm(char *dir)
{
  if(dvm_dll)
    return 1;

  CoInitialize(NULL);

  char path[MAX_PATH];
  GetModuleFileName(NULL,path,MAX_PATH);
  size_t pos=strlen(path)-1;
  while(pos)
  {
    if(path[pos]=='\\')
    {
      pos++;
      path[pos]=0;
      break;
    }
    pos--;
  }

  SetCurrentDirectory(dir);

  //load dsRE core dll "dsRE.dll"
  dvm_dll=LoadLibraryEx("dsRE.dll",NULL,LOAD_WITH_ALTERED_SEARCH_PATH);

  CreateVM=(dbool (_stdcall *)(dVM **))GetProcAddress(dvm_dll,"CreateVM");
  ReleaseVM=(void (_stdcall *)(dVM *))GetProcAddress(dvm_dll,"ReleaseVM");

  if(dvm_dll==NULL || CreateVM==NULL || ReleaseVM==NULL)
  {
    MessageBox(NULL,"Can NOT load dsRE !","dsRE",MB_OK);
    return false;
  }

  //create dsRE virtual machine
  CreateVM(&g_RuntimeVars.vm);
  g_RuntimeVars.vm->GetDefaultEnv(&g_RuntimeVars.env);
  g_RuntimeVars.factory=g_RuntimeVars.env->CreateFactory();
  g_RuntimeVars.factory->functions->FindClass=FindClass;
  g_RuntimeVars.factory->functions->WrapExistsInstance=WrapExistsInstance;

  if(g_RuntimeVars.vm->LoadBridge(L"VCL_Bridge.dll",L"")==NULL)
    MessageBox(NULL,"Can't load 'VCL_Bridge.dll'.","Composite Bridges",MB_OK);

  if(g_RuntimeVars.vm->LoadBridge(L"MSCOM_Bridge.dll",L"")==NULL)
    MessageBox(NULL,"Can't load 'MSCOM_Bridge.dll'.","Composite Bridges",MB_OK);

  if(g_RuntimeVars.vm->LoadBridge(L"JScript_Bridge.dll",L"")==NULL)
    MessageBox(NULL,"Can't load 'JScript_Bridge.dll'.","Composite Bridges",MB_OK);

  if(g_RuntimeVars.vm->LoadBridge(L"Winapi_Bridge.dll",L"")==NULL)
    MessageBox(NULL,"Can't load 'Winapi_Bridge.dll'.","Composite Bridges",MB_OK);

  SetCurrentDirectory(path);//change to application path

  //test php5ts.dll
  if(g_RuntimeVars.vm->LoadBridge(L"php_dsRE.dll",NULL)==NULL)
  {
    char inifname[MAX_PATH];
    strcpy(inifname,path);
    strcpy(inifname+pos,"Externtion.INI");

    char dllfname[MAX_PATH];

    strcpy(dllfname,path);
    strcpy(dllfname+pos,"php5ts.dll");

    char phpds_dll[MAX_PATH];

    GetPrivateProfileString("Client","php5ts.dll",dllfname,phpds_dll,MAX_PATH,inifname);
    if(GetFileAttributes(phpds_dll)==INVALID_FILE_ATTRIBUTES)//can't find it
    {
      OPENFILENAME ofn;
      memset(&ofn,0,sizeof(ofn));
      ofn.lStructSize = sizeof(OPENFILENAME);
      ofn.lpstrFile = phpds_dll;
      ofn.nMaxFile = sizeof(phpds_dll);
      ofn.lpstrFilter = "Where is php5ts.dll?\0php5ts.dll";
      ofn.lpstrFileTitle = "Where is php5ts.dll?";
      ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST; 
      if(GetOpenFileName(&ofn))
      {
        if(GetFileAttributes(phpds_dll)!=INVALID_FILE_ATTRIBUTES)//found php5ts.dll
        {
          WritePrivateProfileString("Client","php5ts.dll",phpds_dll,inifname);
        }else
        {
          phpds_dll[0]=0;
        }
      }else
      {
        phpds_dll[0]=0;
      }
    }
    if(phpds_dll[0])
    {
      pos=strlen(phpds_dll)-1;
      while(pos)
      {
        if(phpds_dll[pos]=='\\')
        {
        pos++;
        phpds_dll[pos]=0;
          SetCurrentDirectory(phpds_dll);
        break;
        }
        pos--;
      }
    }
    
	if(g_RuntimeVars.vm->LoadBridge(L"php_dsRE.dll",NULL)==NULL)
      MessageBox(NULL,"Can't load 'php_dsRE.dll'.","Composite Bridges",MB_OK);
  }

  SetCurrentDirectory(path);

  return true;
}

extern "C"
void SimpleRelease_dvm()
{
  if(ReleaseVM)
    ReleaseVM(g_RuntimeVars.vm);

  memset(&g_RuntimeVars,0,sizeof(g_RuntimeVars));

  FreeLibrary(dvm_dll);
  dvm_dll=NULL;
}


extern "C"
void Reload_dvm(char *dir)
{
    if(dvm_dll)
        SimpleRelease_dvm();
    SimpleCreate_dvm(dir);
  CoUninitialize();
}

//dsRE code -)
