// Copyright (c) Luodiping 2006
// Use & modify as you want & need, and leave those 3 lines.
// http://duceland.com

#ifndef GlobalFuncH
#define GlobalFuncH

#include <stdio.h>
#include <string.h>

#ifdef _INTER_VER_
# include "dni.hpp"
#else
# include "dni.h"
#endif

template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>
inline void *GetFunctionPointer(ReturnType (__stdcall X::* function_to_bind)(Param1,Param2,Param3,Param4))
{
  typedef ReturnType (__stdcall X::*LocalFunctionType)(Param1,Param2,Param3,Param4);
  struct {
    LocalFunctionType Func;
  }A;
  A.Func=function_to_bind;
  void **p=(void **)&A;
  return *p;
}

#define MAKE_INT64(o,p) (p<<32+o)

//- - - - -
#ifdef _INTER_VER_
void InvokeMethod(dEnv *env,dFactory* factory,dobject sender,dMethod *method,pAutoArg args,dValue *ret_val);
inline void InvokeMethod(dEnv *env,dFactory* factory,dobject sender,dMethod *method,dValue *v0,dValue *ret_val)
{
  dAutoArg arg;
  arg<<v0;
  InvokeMethod(env,factory,sender,method,&arg,ret_val);
}
inline void InvokeMethod(dEnv *env,dFactory* factory,dobject sender,dMethod *method,dValue *v0,dValue *v1,dValue *ret_val)
{
  dAutoArg arg;
  arg<<v0;
  arg<<v1;
  InvokeMethod(env,factory,sender,method,&arg,ret_val);
}
inline void InvokeMethod(dEnv *env,dFactory* factory,dobject sender,dMethod *method,dValue *v0,dValue *v1,dValue *v2,dValue *ret_val)
{
  dAutoArg arg;
  arg<<v0;
  arg<<v1;
  arg<<v2;
  InvokeMethod(env,factory,sender,method,&arg,ret_val);
}
inline void InvokeMethod(dEnv *env,dFactory* factory,dobject sender,dMethod *method,dValue *v0,dValue *v1,dValue *v2,dValue *v3,dValue *ret_val)
{
  dAutoArg arg;
  arg<<v0;
  arg<<v1;
  arg<<v2;
  arg<<v3;
  InvokeMethod(env,factory,sender,method,&arg,ret_val);
}
inline void InvokeMethod(dEnv *env,dFactory* factory,dobject sender,dMethod *method,dValue *v0,dValue *v1,dValue *v2,dValue *v3,dValue *v4,dValue *ret_val)
{
  dAutoArg arg;
  arg<<v0;
  arg<<v1;
  arg<<v2;
  arg<<v3;
  arg<<v4;
  InvokeMethod(env,factory,sender,method,&arg,ret_val);
}
#endif //#ifdef _INTER_VER_

//---------------------------------------------------------------------------
bool ParseArgumentW(const dchararray source,pAutoArg param);
bool ParseArgument(const char *source,pAutoArg param);

inline bool Argument2String(dValue *v,LWideString &w)
{
  dchar s[600];
  bool b=true;
  switch(v->vt)
  {
  case vt_bool:
    swprintf(s,L"%d",(int)v->v.b);;
    w.Add(s);
    break;
  case vt_byte:
    swprintf(s,L"%d",(int)v->v.y);;
    w.Add(s);
    break;
  case vt_char:
    swprintf(s,L"%d",(int)v->v.c);;
    w.Add(s);
    break;
  case vt_short:
    swprintf(s,L"%d",(int)v->v.s);;
    w.Add(s);
    break;
  case vt_float:
    swprintf(s,L"%f",v->v.f);
    w.Add(s);
    break;
  case vt_double:
    swprintf(s,L"%f",(float)v->v.d);
    w.Add(s);
    break;
  case vt_int:
    swprintf(s,L"%d",(int)v->v.i);
    w.Add(s);
    break;
  case vt_size:
    _i64tow(v->v.z,s,10);
    w.Add(s);
    break;
  case vt_string:
    w.Add(L'\"');
    w.Add(v->o.s->GetText());
    w.Add(L'\"');
    break;
  default:
    b=false;
    break;
  }
  return b;
}
inline void Arguments2String(pAutoArg param,LWideString &w)
{
  bool b;
  for(int i=0;i<param->count;i++)
  {
    b=Argument2String((*param)[i],w);
    if(b && i+1<param->count)
    {
      w.Add(L',');
    }
  }
}

#endif //#ifndef GlobalFuncH
