// Written by Luodiping 2008
// Use & modify as you want & need, and leave those 3 lines.
// http://duceland.com

//---------------------------------------------------------------------------
#ifndef LWideStringH
#define LWideStringH
#include <stdlib.h>

#ifndef dobject
struct _dobject;
typedef _dobject*        dobject;
#endif

//---------------------------------------------------------------------------
class LWideString
{
public:LWideString();
public:LWideString(const LWideString &rhs);
public:LWideString(const wchar_t *rhs);
public:~LWideString();

protected:wchar_t *Text;
protected:int AllocSize;
protected:int TextLength;
public:wchar_t *GetText()const;
public:int GetLength()const;
public:void ResetSize(int len);
public:void SetLength(int len);

public:LWideString &operator=(const LWideString &rhs);
public:LWideString &operator=(unsigned char *rhs);
public:LWideString &operator=(const char *rhs);
public:LWideString &operator=(const wchar_t *rhs);
public:bool operator==(LWideString &rhs);
public:bool operator==(unsigned char *rhs);
public:bool operator==(wchar_t *rhs);
public:bool operator!=(LWideString &rhs);
public:bool operator!=(unsigned char *rhs);
public:bool operator!=(wchar_t *rhs);
public:bool operator<(const LWideString &rhs) const;

public:void Clear();
public:LWideString &Add(wchar_t c);
public:LWideString &Add(wchar_t *s);
public:LWideString &Add(LWideString &s);
public:wchar_t &operator[](int index);
public:wchar_t Get(int index);

public:LWideString &Copy(wchar_t *rhs,int wchar_len);
public:LWideString &Copy(unsigned char *rhs,int char_len);

public:LWideString &Insert(int pos,const LWideString &source);
public:LWideString &Append(const LWideString &source);
public:LWideString &Insert(int pos,wchar_t *source);
public:LWideString &Append(wchar_t *source);

public:LWideString &operator+=(LWideString &source);
public:LWideString &operator+=(wchar_t *source);
public:LWideString &operator+=(wchar_t source);

public:LWideString &Replace(int pos,int replaced_len,wchar_t *source);
public:LWideString &Replace(int pos,int replaced_len,LWideString &source);

public:int Compare(wchar_t *large_then_me)const;
public:int Compare(unsigned char *large_then_me)const;
public:int Compare(wchar_t* large_then_me,int char_len)const;
public:int Compare(unsigned char *large_then_me,int char_len)const;
public:int Compare(const LWideString &s)const;
public:int Compare(const LWideString *s)const;
public:void Trim();
public:size_t Str(wchar_t *str);
public:LWideString SubString(int pos,int len);
};
//---------------------------------------------------------------------------

#ifdef __cplusplus
extern "C"{
#endif

size_t MultiBytesToWides(wchar_t *pwcs, const char *s, size_t n);
size_t WidesToMultiBytes(char *s,const wchar_t *pwcs, size_t n);
void ToLower(wchar_t *pwcs);

#ifdef __cplusplus
}
#endif


//---------------------------------------------------------------------------
class LWideStrings
{
public:LWideStrings();
public:~LWideStrings();

protected:int AllocSize;
protected:int LineCount;
protected:LWideString ** Strings;

public:LWideString *GetLine(int index);
public:int GetLineCount();

public:void Clear();
protected:void GrowSize();
public:void Add(LWideString &s);
public:void Add(LWideString *s);
public:void Copy(LWideStrings &s);

public:bool Contain(LWideString &s);
public:bool Contain(LWideString *s);
};
//---------------------------------------------------------------------------
#endif
