#include <windows.h>

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
char szClassName[ ] = "WindowsApp";

RECT GetScreenClient()
{
  RECT d,rect,client;
  HWND desktop,bar;
  desktop=GetDesktopWindow();
  bar=FindWindowEx(desktop,NULL,"Shell_TrayWnd",NULL);
  GetWindowRect(desktop,&d);
  GetWindowRect(bar,&rect);
  if(rect.left<d.left)
    rect.left=d.left;
  if(rect.top<d.top)
    rect.top=d.top;
  if(rect.right>d.right)
    rect.right=d.right;
  if(rect.bottom>d.bottom)
    rect.bottom=d.bottom;
  if(rect.right==d.right && rect.bottom==d.bottom)
  {
    if(rect.top==d.top)
    {
      //right
      client.left=d.left;
      client.top=d.top;
      client.right=rect.left;
      client.bottom=d.bottom;
    }
    else
    {
      //bottom
      client.left=d.left;
      client.top=d.top;
      client.right=d.right;
      client.bottom=rect.top;
    }
  }else if(rect.left==d.left)
  {
    if(rect.bottom==d.bottom)
    {
      //left
      client.left=rect.right;
      client.top=d.top;
      client.right=d.right;
      client.bottom=d.bottom;
    }
    else
    {
      //top
      client.left=d.left;
      client.top=rect.bottom;
      client.right=d.right;
      client.bottom=d.bottom;
    }
  }
  return client;
}

//(- dsRE code
#include "dni.h"
#include "GlobalFunc.h"

RuntimeVars_t g_RuntimeVars={0,0,0};
HMODULE dvm_dll=NULL;
dbool (_stdcall *CreateVM)(dVM **vm);
void (__stdcall *ReleaseVM)(dVM *vm);
bool SimpleCreate_dvm(dVM **vm,dEnv **env,dFactory **factory)
{
  //load dsRE core dll "dsRE.dll"
  dvm_dll=LoadLibrary("dsRE.dll");

  CreateVM=(dbool (_stdcall *)(dVM **))GetProcAddress(dvm_dll,"CreateVM");
  ReleaseVM=(void (_stdcall *)(dVM *))GetProcAddress(dvm_dll,"ReleaseVM");

  if(dvm_dll==NULL || CreateVM==NULL || ReleaseVM==NULL)
  {
    MessageBox(NULL,"Can NOT load dsRE !","dsRE",MB_OK);
    return false;
  }

  //create dsRE virtual machine
  CreateVM(vm);
  (*vm)->GetDefaultEnv(env);
  *factory=(*env)->CreateFactory();

  return true;
}
void SimpleRelease_dvm()
{
  if(ReleaseVM)
    ReleaseVM(g_RuntimeVars.vm);
  FreeLibrary(dvm_dll);
}

//sample to create a CSharp UI
struct CSharpUICppBL
{
  void dcall OnButton1Click(dMethod *method,dobject sender,pAutoArg args,dValue *ret_val)
  {
    dValue v,text;
    Memo1->GetField(NULL,L"Text",&text);
    text.o.s->Add(L"Button1 clicked.\r\n");
    Memo1->SetField(NULL,L"Text",&text);
  }
  void dcall OnEdit1Change(dMethod *method,dobject sender,pAutoArg args,dValue *ret_val)
  {
    dValue v,text,ret;
    Memo1->GetField(NULL,L"Text",&text);
    Edit1->GetField(NULL,L"Text",&ret);
    text.o.s->Add(L"Edit1 changed(\"");
    text.o.s->Add(ret.o.s->GetText());
    text.o.s->Add(L"\")\r\n");
    Memo1->SetField(NULL,L"Text",&text);
  }

  dobject Button1,Edit1,Memo1;
  dobject UI;
}g_CSharpUICppBL;
void CreateCSharpUI(HWND hwnd)
{
  dValue v,ret,empty;
  dobject dn_bridge;

  if(!SimpleCreate_dvm(&(g_RuntimeVars.vm),&(g_RuntimeVars.env),&(g_RuntimeVars.factory)))
    return;
  g_RuntimeVars.env->SetMainWndHandle(hwnd);
  g_RuntimeVars.vm->LoadBridge(L"DotNET_Bridge_ThroughVC.dll",L"");

  dn_bridge=g_RuntimeVars.env->NewDefaultObject((dobject)NULL,L"DotNET_Bridge",&v);
  dn_bridge->Invoke((dobject)NULL,L"LoadDotNETLibrary",L"CSharpUI.dll",&ret);

  g_CSharpUICppBL.UI=g_RuntimeVars.env->NewDefaultObject((dobject)NULL,L"CSharpUI.CSharpForm",&empty);
  g_CSharpUICppBL.UI->Invoke((dobject)NULL,L"StartupMe",&ret);

  g_CSharpUICppBL.Button1=g_RuntimeVars.env->GetSharedObject(L"Button1");
  g_CSharpUICppBL.Button1->RegistMethod((dobject)&g_CSharpUICppBL,NULL,BASE_CALL,GetFunctionPointer(&CSharpUICppBL::OnButton1Click),L"Click",L"",vt_void);

  g_CSharpUICppBL.Edit1=g_RuntimeVars.env->GetSharedObject(L"Edit1");
  g_CSharpUICppBL.Edit1->RegistMethod((dobject)&g_CSharpUICppBL,NULL,BASE_CALL,GetFunctionPointer(&CSharpUICppBL::OnEdit1Change),L"TextChanged",L"",vt_void);

  g_CSharpUICppBL.Memo1=g_RuntimeVars.env->GetSharedObject(L"Memo1");
}
void FinalyzeCSharpUI()
{
  g_RuntimeVars.vm->UnallocObject((dobject)NULL,g_CSharpUICppBL.UI);
  SimpleRelease_dvm();
}
//dsRE code -)

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */
    RECT client=GetScreenClient();
    int l,t,w,h;
    w=544;
    h=375;
    l=((client.right-client.left)-w)/2;
    t=((client.bottom-client.top)-h)/2;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Windows App",       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           l,                   /* Windows decides the position */
           t,                   /* where the window ends up on the screen */
           w,                   /* The programs width */
           h,                   /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);

    CreateCSharpUI(hwnd);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);

        if(g_RuntimeVars.vm)
          g_RuntimeVars.vm->DoDispatch(NULL);
    }

    FinalyzeCSharpUI();

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)                  /* handle the messages */
  {
    case WM_DESTROY:
      PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
      break;
    default:                      /* for messages that we don't deal with */
      return DefWindowProc (hwnd, message, wParam, lParam);
  }

  return 0;
}
