using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

public class DelphiUICSharpBL
{
	private dVM dvm;
	public DelphiUICSharpBL(dVM vm)
	{
		dvm=vm;
	}
	public string OnButton1Click(string method_name,string sender,string param)
	{
		dobject lines=Memo1.GetField("Lines");
		string v="\"Button1 clicked.\"";
		return lines.Invoke(null,"Add",v).ToString();
	}
	public string OnEdit1Change(string method_name,string sender,string param)
	{
		dobject lines=Memo1.GetField("Lines");
		string text=Edit1.GetField("Text").ToString();
		string v="\"Edit1 changed("+text+").\"";
		return lines.Invoke(null,"Add",v).ToString();
	}
	public dobject Button1,Edit1,Memo1;

	//create a Delphi user interface.
	public void CreateDelphiUI()
	{
		dobject obj;
		obj=dvm.DefaultNewObject("DelphiForm","");
		obj.Invoke(null,"StartupMe","");

		Button1=dvm.GetSharedObject("Button1");
		dvm.DelegatedStdcall(Button1,"OnClick","",0,this,"OnButton1Click");

		Edit1=dvm.GetSharedObject("Edit1");
		dvm.DelegatedStdcall(Edit1,"OnChange","",0,this,"OnEdit1Change");

		Memo1=dvm.GetSharedObject("Memo1");
	}
}

namespace DelphiUI_CSharpBL
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form design code
		/// <summary>
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(416, 141);
			this.Name = "Form1";
			this.Text = "Delphi UI C# BL";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private DelphiUICSharpBL ui;
		private static dVM dvm;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			//new a dVM,to finish other target.
			dvm=new dVM();

			ui=new DelphiUICSharpBL(dvm);
			dvm.LoadBridge("VCL_Bridge.dll","");
			dobject vcl_bridge=dvm.DefaultNewObject("VCL_Bridge","");
			vcl_bridge.Invoke(null,"LoadDelphiLibrary","\"DelphiUI.dll\"");
			ui.CreateDelphiUI();
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			dvm.ReleaseVM();
		}
	}
}
