using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

public class JavaUICSharpBL
{
	private dVM dvm;
	public JavaUICSharpBL(dVM vm)
	{
		dvm=vm;
	}
	public string OnButton1Click(string method_name,string sender,string param)
	{
		string v="\"\nButton1 clicked.\"";
		return Memo1.Invoke(null,"append",v).ToString();
	}
	public string OnEdit1Change(string method_name,string sender,string param)
	{
		string v="\"\nEdit1 changed.\"";
		return Memo1.Invoke(null,"append",v).ToString();
	}
	public dobject Button1,Edit1,Memo1;

	//create a java user interface.
	public void CreateJavaUI()
	{
		dobject obj;
		obj=dvm.DefaultNewObject("SwingApplication","");
		obj.Invoke(null,"StartupMe","");

		Button1=dvm.GetSharedObject("Button1");
		dvm.DelegatedStdcall(Button1,"actionPerformed","",0,this,"OnButton1Click");

		Edit1=dvm.GetSharedObject("Edit1");
		dvm.DelegatedStdcall(Edit1,"keyPressed","",0,this,"OnEdit1Change");

		Memo1=dvm.GetSharedObject("Memo1");
	}
}

namespace JavaUI_CSharpBL
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form design code
		/// <summary>
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(416, 141);
			this.Name = "Form1";
			this.Text = "Java UI C# BL";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private JavaUICSharpBL ui;
		private static dVM dvm;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			//new a dVM,to finish other target.
			dvm=new dVM();

			ui=new JavaUICSharpBL(dvm);
			dvm.LoadBridge("Java_Bridge.dll","");
			ui.CreateJavaUI();
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			dvm.ReleaseVM();
		}
	}
}
