// Copyright (c) Luodiping 2006
// Use & modify as you want & need, and leave those 3 lines.
// http://duceland.com

#ifndef VCLGlobalH
#define VCLGlobalH
//---------------------------------------------------------------------------
#include "dni.h"

dint GetStringType(const wchar_t* stype);

#define ShareExists(cls_name,be_shared_obj,share_name)                                \
  {                                                                                   \
    dobject obj=g_RuntimeVars.env->WrapExistsInstance(cls_name,be_shared_obj);       \
    if(obj)                                                                           \
    {                                                                                 \
      g_RuntimeVars.factory->Share((dobject)g_RuntimeVars.factory,obj,share_name);    \
    }                                                                                 \
  }
//translate ds arguments to BCB and call the function pointer
#ifdef __BORLANDC__
inline void Translate1Arg2BCB(AnsiString &p,dValue *v)
{
  p=v->AsString()->GetText();
}
inline void Translate1Arg2BCB(WideString &p,dValue *v)
{
  p=v->AsString()->GetText();
}
inline void Translate1Arg2BCB(char *p,dValue *v)
{
  WideString w=v->AsString()->GetText();
  AnsiString s=w;
  strcpy(p,s.c_str());
}
#endif
#ifdef _MSC_VER
inline void Translate1Arg2BCB(DWORD &p,dValue *v)
{
  p=v->AsInt();
}
inline void Translate1Arg2BCB(CString &p,dValue *v)
{
  p=v->AsString()->GetText();
}
#endif
inline void Translate1Arg2BCB(bool &p,dValue *v)
{
  p=v->AsBool();
}
inline void Translate1Arg2BCB(dbool &p,dValue *v)
{
  p=v->AsBool();
}
inline void Translate1Arg2BCB(dbyte &p,dValue *v)
{
  p=v->AsByte();
}
inline void Translate1Arg2BCB(dshort &p,dValue *v)
{
  p=v->AsShort();
}
inline void Translate1Arg2BCB(dfloat &p,dValue *v)
{
  p=v->AsShort();
}
inline void Translate1Arg2BCB(ddouble &p,dValue *v)
{
  p=v->AsDouble();
}
inline void Translate1Arg2BCB(dld &p,dValue *v)
{
  p=v->AsLongDouble();
}
inline void Translate1Arg2BCB(dint &p,dValue *v)
{
  p=v->AsInt();
}
inline void Translate1Arg2BCB(dchararray &p,dValue *v)
{
  p=v->AsString()->GetText();
}
inline void Translate1Arg2BCB(unsigned char *&p,dValue *v)
{
  #ifdef __BORLANDC__
  AnsiString s=v->AsString()->GetText();
  p=s.c_str();
  #endif
}
inline void Translate1Arg2BCB(dobject &p,dValue *v)
{
  p=v->AsObject();
}
inline void Translate1Arg2BCB(void* &p,dValue *v)
{
  p=v->AsObject();
}
template <typename BCBType>
inline void Translate1Arg2BCB(BCBType &p,dValue *v)
{
  switch(v->vt)
  {
  case vt_void:
    {
      BCBType b=BCBType();
      memcpy((void *)&p,&b,sizeof(BCBType));
    }
    break;
  case vt_object:
    //impl->clone->vcl pointer
    if(v->o.o)
    {
      if(v->o.o->inst)
        memcpy((void *)&p,&(v->o.o->inst->inst),sizeof(dobject));
      else
        memset((void *)&p,0,sizeof(dobject));
    }
    else
      memset((void *)&p,0,sizeof(dobject));
    break;
  case vt_lobject:
    memcpy((void *)&p,&(v->o.o),sizeof(dobject));
    break;
  default:
    if(v->vt>vt_object)
    {
      memcpy((void *)&p,&(v->v.reserved),sizeof(BCBType));
    }else
    {
      BCBType b=BCBType();
      memcpy((void *)&p,&b,sizeof(BCBType));
    }
  }
}
#ifdef __BORLANDC__
inline void TranslateBCB2dValue(dValue *v,dint vt,AnsiString &p)
{
  WideString w=p;
  (*v)=w.c_bstr();
}
inline void TranslateBCB2dValue(dValue *v,dint vt,WideString &p)
{
  (*v)=p.c_bstr();
}
inline void TranslateBCB2dValue(dValue *v,dint vt,const char *p)
{
  WideString w=p;
  (*v)=w.c_bstr();
}
#endif
inline void TranslateBCB2dValue(dValue *v,dint vt,bool &p)
{
  (*v)=(dbool)p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dbool &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dbyte &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dshort &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dfloat &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,ddouble &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dld &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dint &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dchararray &p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,const unsigned char *p)
{
  TranslateBCB2dValue(v,vt,p);
}
inline void TranslateBCB2dValue(dValue *v,dint vt,dobject p)
{
  (*v)=p;
}
inline void TranslateBCB2dValue(dValue *v,dint vt,void* p)
{
  (*v)=p;
}

inline void *GetObjectPointer(void* p)
{
  return (dobject)p;
}
template <typename BCBType>
inline void *GetObjectPointer(BCBType *p)
{
  return (dobject)p;
}
template <typename BCBType>
inline void *GetObjectPointer(BCBType p)
{
  return NULL;
}
template <typename BCBType>
inline void TranslateBCB2dValue(dValue *v,dint vt,BCBType &p)
{
  switch(vt)
  {
  case vt_void:
    (*v)=0;
    break;
  default:
    if(vt>=vt_object)
    {
      void *pointer=GetObjectPointer(p);
      dobject shell;
      if(sizeof(BCBType)==sizeof(void *))
      {
        wchar_t cls_name[100];
        const char *pname=typeid(BCBType).name();
        char sname[128];
        int i;
        for(i=0;i<sizeof(sname) && pname[i];i++)
        {
          if((pname[i]>='a' && pname[i]<='z') || (pname[i]>='A' && pname[i]<='Z') || pname[i]=='_')
          {
            sname[i]=pname[i];
          }
          else
          {
            break;
          }
        }
        sname[i]=0;
        MultiBytesToWides(cls_name,sname,strlen(sname));
        shell=g_RuntimeVars.env->ShellExistsInstance(cls_name,pointer);
      }
      if(shell)
      {
        (*v)=shell;
      }else
      {
        memcpy(&(v->v.reserved),&p,sizeof(BCBType));//may be a enum
        v->vt=vt_vclobject;
      }
    }else
    {
      (*v)=(void *)0;
    }
  }
}

//no param and no return
template <class X>
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(),pAutoArg args,dchararray param,dValue *ret_val,dint vt_ret)
{
  (pthis->*function)();
}
//no param and have return
template <class X,typename ReturnType>
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(),pAutoArg args,dchararray param,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  ret=(pthis->*function)();
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}

//1 param and no return
template <class X,typename Param1>
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&),pAutoArg args,dchararray param,Param1& p1,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  (pthis->*function)(p1);
}
template <class X,typename Param1>
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1),pAutoArg args,dchararray param,Param1& p1,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  (pthis->*function)(p1);
}

//1 param and have return
template <class X,typename ReturnType,typename Param1>
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&),pAutoArg args,dchararray param,Param1& p1,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  ret=(pthis->*function)(p1);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1>
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1),pAutoArg args,dchararray param,Param1& p1,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  ret=(pthis->*function)(p1);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}

//2 param and no return
template <class X,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  (pthis->*function)(p1,p2);
}
template <class X,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  (pthis->*function)(p1,p2);
}
template <class X,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  (pthis->*function)(p1,p2);
}
template <class X,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  (pthis->*function)(p1,p2);
}
//2 param and have return
template <class X,typename ReturnType,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  ret=(pthis->*function)(p1,p2);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  ret=(pthis->*function)(p1,p2);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  ret=(pthis->*function)(p1,p2);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2>
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2),pAutoArg args,dchararray param,Param1 p1,Param2 p2,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  ret=(pthis->*function)(p1,p2);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}

//3 param and no return
template <class X,typename Param1,typename Param2,typename Param3>//111
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2&,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
template <class X,typename Param1,typename Param2,typename Param3>//110
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2&,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
template <class X,typename Param1,typename Param2,typename Param3>//101
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
template <class X,typename Param1,typename Param2,typename Param3>//100
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
template <class X,typename Param1,typename Param2,typename Param3>//011
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2&,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
template <class X,typename Param1,typename Param2,typename Param3>//010
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2&,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
template <class X,typename Param1,typename Param2,typename Param3>//001
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
template <class X,typename Param1,typename Param2,typename Param3>//000
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  (pthis->*function)(p1,p2,p3);
}
//3 param and have return
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//111
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2&,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//110
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2&,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//101
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//100
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//011
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2&,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//010
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2&,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//001
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3>//000
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  ret=(pthis->*function)(p1,p2,p3);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}

//4 param and no return
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1111
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2&,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1110
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2&,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1101
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2&,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1100
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2&,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1011
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1010
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1001
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//1000
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1&,Param2,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0111
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2&,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0110
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2&,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0101
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2&,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0100
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2&,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0011
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0010
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0001
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4>//0000
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  (pthis->*function)(p1,p2,p3,p4);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4,typename Param5>//00000
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3,Param4,Param5),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,Param5 p5,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  Translate1Arg2BCB(p5,(*args)[4]);
  (pthis->*function)(p1,p2,p3,p4,p5);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4,typename Param5,typename Param6>//000000
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3,Param4,Param5,Param6),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,Param5 p5,Param6 p6,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  Translate1Arg2BCB(p5,(*args)[4]);
  Translate1Arg2BCB(p6,(*args)[5]);
  (pthis->*function)(p1,p2,p3,p4,p5,p6);
}
template <class X,typename Param1,typename Param2,typename Param3,typename Param4,typename Param5,typename Param6,typename Param7>//0000000
inline void TranslateArgs2BCB(X* pthis,void (dcall X::* function)(Param1,Param2,Param3,Param4,Param5,Param6,Param7),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,Param5 p5,Param6 p6,Param7 p7,dValue *ret_val,dint vt_ret)
{
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  Translate1Arg2BCB(p5,(*args)[4]);
  Translate1Arg2BCB(p6,(*args)[5]);
  Translate1Arg2BCB(p7,(*args)[6]);
  (pthis->*function)(p1,p2,p3,p4,p5,p6,p7);
}

//4 param and have return
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1111
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2&,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1110
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2&,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1101
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2&,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1100
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2&,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1011
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1010
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1001
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//1000
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1&,Param2,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0111
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2&,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0110
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2&,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0101
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2&,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0100
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2&,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0011
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3&,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0010
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3&,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0001
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3,Param4&),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4>//0000
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3,Param4),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  ret=(pthis->*function)(p1,p2,p3,p4);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4,typename Param5>//00000
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3,Param4,Param5),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,Param5 p5,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  Translate1Arg2BCB(p5,(*args)[4]);
  ret=(pthis->*function)(p1,p2,p3,p4,p5);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4,typename Param5,typename Param6>//000000
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3,Param4,Param5,Param6),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,Param5 p5,Param6 p6,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  Translate1Arg2BCB(p5,(*args)[4]);
  Translate1Arg2BCB(p6,(*args)[5]);
  ret=(pthis->*function)(p1,p2,p3,p4,p5,p6);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}
template <class X,typename ReturnType,typename Param1,typename Param2,typename Param3,typename Param4,typename Param5,typename Param6,typename Param7>//0000000
inline void TranslateArgs2BCB(X* pthis,ReturnType (dcall X::* function)(Param1,Param2,Param3,Param4,Param5,Param6,Param7),pAutoArg args,dchararray param,Param1 p1,Param2 p2,Param3 p3,Param4 p4,Param5 p5,Param6 p6,Param7 p7,dValue *ret_val,dint vt_ret)
{
  ReturnType ret;
  Translate1Arg2BCB(p1,(*args)[0]);
  Translate1Arg2BCB(p2,(*args)[1]);
  Translate1Arg2BCB(p3,(*args)[2]);
  Translate1Arg2BCB(p4,(*args)[3]);
  Translate1Arg2BCB(p5,(*args)[4]);
  Translate1Arg2BCB(p6,(*args)[5]);
  Translate1Arg2BCB(p7,(*args)[6]);
  ret=(pthis->*function)(p1,p2,p3,p4,p5,p6,p7);
  TranslateBCB2dValue(ret_val,vt_ret,ret);
}

//translate BCB arguments to ds and call the function pointer
template <typename BCBType1>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1)
{
  args->del=true;

  dValue *pp1=new dValue();

  Translate1Arg2BCB(p1,pp1);

  (*args)<<pp1;
}
template <typename BCBType1,typename BCBType2>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);

  (*args)<<pp1<<pp2;
}
template <typename BCBType1,typename BCBType2,typename BCBType3>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2,BCBType3 &p3)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();
  dValue *pp3=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);
  Translate1Arg2BCB(p3,pp3);

  (*args)<<pp1<<pp2<<pp3;
}
template <typename BCBType1,typename BCBType2,typename BCBType3,typename BCBType4>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2,BCBType3 &p3,BCBType4 &p4)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();
  dValue *pp3=new dValue();
  dValue *pp4=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);
  Translate1Arg2BCB(p3,pp3);
  Translate1Arg2BCB(p4,pp4);

  (*args)<<pp1<<pp2<<pp3<<pp4;
}
template <typename BCBType1,typename BCBType2,typename BCBType3,typename BCBType4,typename BCBType5>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2,BCBType3 &p3,BCBType4 &p4,BCBType5 &p5)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();
  dValue *pp3=new dValue();
  dValue *pp4=new dValue();
  dValue *pp5=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);
  Translate1Arg2BCB(p3,pp3);
  Translate1Arg2BCB(p4,pp4);
  Translate1Arg2BCB(p5,pp5);

  (*args)<<pp1<<pp2<<pp3<<pp4<<pp5;
}
template <typename BCBType1,typename BCBType2,typename BCBType3,typename BCBType4,typename BCBType5,typename BCBType6>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2,BCBType3 &p3,BCBType4 &p4,BCBType5 &p5,BCBType6 &p6)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();
  dValue *pp3=new dValue();
  dValue *pp4=new dValue();
  dValue *pp5=new dValue();
  dValue *pp6=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);
  Translate1Arg2BCB(p3,pp3);
  Translate1Arg2BCB(p4,pp4);
  Translate1Arg2BCB(p5,pp5);
  Translate1Arg2BCB(p6,pp6);

  (*args)<<pp1<<pp2<<pp3<<pp4<<pp5<<pp6;
}
template <typename BCBType1,typename BCBType2,typename BCBType3,typename BCBType4,typename BCBType5,typename BCBType6,typename BCBType7>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2,BCBType3 &p3,BCBType4 &p4,BCBType5 &p5,BCBType6 &p6,BCBType7 &p7)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();
  dValue *pp3=new dValue();
  dValue *pp4=new dValue();
  dValue *pp5=new dValue();
  dValue *pp6=new dValue();
  dValue *pp7=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);
  Translate1Arg2BCB(p3,pp3);
  Translate1Arg2BCB(p4,pp4);
  Translate1Arg2BCB(p5,pp5);
  Translate1Arg2BCB(p6,pp6);
  Translate1Arg2BCB(p7,pp7);

  (*args)<<pp1<<pp2<<pp3<<pp4<<pp5<<pp6<<pp7;
}
template <typename BCBType1,typename BCBType2,typename BCBType3,typename BCBType4,typename BCBType5,typename BCBType6,typename BCBType7,typename BCBType8>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2,BCBType3 &p3,BCBType4 &p4,BCBType5 &p5,BCBType6 &p6,BCBType7 &p7,BCBType8 &p8)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();
  dValue *pp3=new dValue();
  dValue *pp4=new dValue();
  dValue *pp5=new dValue();
  dValue *pp6=new dValue();
  dValue *pp7=new dValue();
  dValue *pp8=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);
  Translate1Arg2BCB(p3,pp3);
  Translate1Arg2BCB(p4,pp4);
  Translate1Arg2BCB(p5,pp5);
  Translate1Arg2BCB(p6,pp6);
  Translate1Arg2BCB(p7,pp7);
  Translate1Arg2BCB(p8,pp8);

  (*args)<<pp1<<pp2<<pp3<<pp4<<pp5<<pp6<<pp7<<pp8;
}
template <typename BCBType1,typename BCBType2,typename BCBType3,typename BCBType4,typename BCBType5,typename BCBType6,typename BCBType7,typename BCBType8,typename BCBType9>
inline void CallbackVoidFunc_Arg(pAutoArg args,BCBType1 &p1,BCBType2 &p2,BCBType3 &p3,BCBType4 &p4,BCBType5 &p5,BCBType6 &p6,BCBType7 &p7,BCBType8 &p8,BCBType9 &p9)
{
  args->del=true;

  dValue *pp1=new dValue();
  dValue *pp2=new dValue();
  dValue *pp3=new dValue();
  dValue *pp4=new dValue();
  dValue *pp5=new dValue();
  dValue *pp6=new dValue();
  dValue *pp7=new dValue();
  dValue *pp8=new dValue();
  dValue *pp9=new dValue();

  Translate1Arg2BCB(p1,pp1);
  Translate1Arg2BCB(p2,pp2);
  Translate1Arg2BCB(p3,pp3);
  Translate1Arg2BCB(p4,pp4);
  Translate1Arg2BCB(p5,pp5);
  Translate1Arg2BCB(p6,pp6);
  Translate1Arg2BCB(p7,pp7);
  Translate1Arg2BCB(p8,pp8);
  Translate1Arg2BCB(p9,pp9);

  (*args)<<pp1<<pp2<<pp3<<pp4<<pp5<<pp6<<pp7<<pp8<<pp9;
}
//---------------------------------------------------------------------------
#endif
