//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "test_Winapi_main2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//(- dsRE code
#include "dni.h"
#include "GlobalFunc.h"
#include "VCLGlobal.h"

RuntimeVars_t g_RuntimeVars={0,0,0};
HMODULE dvm_dll=NULL;
dbool (_stdcall *CreateVM)(dVM **vm);
void (__stdcall *ReleaseVM)(dVM *vm);

dobject CreateObjectByInstance(dFactory *factory,dchararray cls_name,void *local_inst);
dobject dcall FindClass
  (dFactory *factory,dchararray name)
{
  dobject dobj=factory->IsClass(name);
  if(dobj==NULL)
  {
    dobj=CreateObjectByInstance(factory,name,NULL);
    if(dobj)
      factory->AddClass(name,dobj);
  }
  if(dobj)//sure vcl class
  {
  }
  return dobj;
}
dobject dcall WrapExistsInstance
  (dFactory *factory,dchararray cls_name,void *local_object)
{
  if(local_object)
  {
  	dobject dobj=CreateObjectByInstance(factory,cls_name,local_object);
    if(dobj)
    {
      dobj->flags|=OF_CREATE_SUCCESS;

      dAutoArg args;
      dValue ret;
      dValue temp;
      args<<&temp<<&temp<<&temp<<&temp;
      dobj->Invoke((dobject)factory,L"_Constructor",&args,&ret);

      dobj->flags|=OF_CONSTRUCT_SUCCESS;
    }
    return dobj;
  }
  return NULL;
}

bool SimpleCreate_dvm()
{
  //load dsRE core dll "dsRE.dll"
  dvm_dll=LoadLibrary("dsRE.dll");

  CreateVM=(dbool (_stdcall *)(dVM **))GetProcAddress(dvm_dll,"CreateVM");
  ReleaseVM=(void (_stdcall *)(dVM *))GetProcAddress(dvm_dll,"ReleaseVM");

  if(dvm_dll==NULL || CreateVM==NULL || ReleaseVM==NULL)
  {
    MessageBox(NULL,"Can NOT load dsRE !","dsRE",MB_OK);
    return false;
  }

  //create dsRE virtual machine
  CreateVM(&g_RuntimeVars.vm);
  g_RuntimeVars.vm->GetDefaultEnv(&g_RuntimeVars.env);
  g_RuntimeVars.factory=g_RuntimeVars.env->CreateFactory();
  g_RuntimeVars.factory->functions->FindClass=FindClass;
  g_RuntimeVars.factory->functions->WrapExistsInstance=WrapExistsInstance;

  return true;
}
void SimpleRelease_dvm()
{
  if(ReleaseVM)
    ReleaseVM(g_RuntimeVars.vm);
  FreeLibrary(dvm_dll);
}

DWORD WINAPI ExecuteThreadProc(LPVOID lpParameter)
{
  dValue v;
  dobject frm=g_RuntimeVars.env->NewDefaultObject((dobject)g_RuntimeVars.factory,L"TForm",&v);

  frm->Invoke((dobject)NULL,L"Show");
	return 0;
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  SetCurrentDirectory("..");
  SimpleCreate_dvm();

	g_RuntimeVars.vm->LoadBridge(L"VCL_Bridge.dll",L"");
  if(g_RuntimeVars.vm->LoadBridge(L"JScript_Bridge.dll",L"")==NULL)
    MessageBox(NULL,"Can't load 'JScript_Bridge.dll'.","Composite Bridges",MB_OK);

  if(g_RuntimeVars.vm->LoadBridge(L"Winapi_Bridge.dll",L"")==NULL)
    MessageBox(NULL,"Can't load 'Winapi_Bridge.dll'.","Composite Bridges",MB_OK);

	DWORD id;
	CreateThread(NULL,10*1024,ExecuteThreadProc,NULL,0,&id);
}
//---------------------------------------------------------------------------

dobject JavaScriptHelper=NULL;

void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
  if(JavaScriptHelper==NULL)
    JavaScriptHelper=g_RuntimeVars.env->GetSharedObject(L"JavaScriptHelper");

  dValue code,ret;
  code=(char *)Memo1->Text.c_str();

  JavaScriptHelper->Invoke(NULL,L"AddCode",&code,&ret);
  if(ret.AsBool()==false)
  {
    Memo2->Lines->Add("AddCode fail");
  }
  else
  {
    Memo2->Lines->Add("AddCode ok");
  }

//  dValue v;
//  dobject test_js_class=g_RuntimeVars.env->NewDefaultObject((dobject)g_RuntimeVars.factory,L"TestJsClass",&v);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
  if(JavaScriptHelper==NULL)
    JavaScriptHelper=g_RuntimeVars.env->GetSharedObject(L"JavaScriptHelper");

  ShareExists(L"TEdit",Edit1,L"Test.Edit1");

  dValue code,ret;
  char code_t[3333];
  strcpy(code_t,Memo3->Text.c_str());
  code=code_t;

  JavaScriptHelper->Invoke(NULL,L"Execute",&code,&ret);
  if(ret.vt==vt_unknown)
  {
    Memo2->Lines->Add("Execute fail");
  }
  else
  {
    Memo2->Lines->Add("Execute ok");
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
  if(JavaScriptHelper==NULL)
    JavaScriptHelper=g_RuntimeVars.env->GetSharedObject(L"JavaScriptHelper");

  dValue v;
  v=L"param p1";
  dobject test_class=g_RuntimeVars.env->NewDefaultObject((dobject)g_RuntimeVars.factory,L"__dsRE_TestClass",&v);

  if(test_class==NULL)
  {
    Memo2->Lines->Add("new __dsRE_TestClass fail");
    return;
  }

  dValue p1,p2,p3,ret;
  p1=123;
  p2=L"abc";
  p3=L"goto 2008";
  test_class->Invoke((dobject)NULL,L"TestFunction",&p1,&p2,&p3,&ret);

  if(ret.vt==vt_unknown)
  {
    Memo2->Lines->Add("call TestFunction fail");
  }
  else
  {
    Memo2->Lines->Add("call TestFunction return:");
    AnsiString s;
    s=ret.AsString()->GetText();
    Memo2->Lines->Add(s);
  }
}
//---------------------------------------------------------------------------

void TestProc()
{
  dValue v;
  dobject test_class=g_RuntimeVars.env->NewDefaultObject((dobject)g_RuntimeVars.factory,L"System.Windows.Forms.Form",&v);
  test_class->Invoke((dobject)NULL,L"Show");

  test_class=g_RuntimeVars.env->NewDefaultObject((dobject)g_RuntimeVars.factory,L"CSharpUI.CSharpForm",&v);
  test_class->Invoke((dobject)NULL,L"StartupMe");
}

void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
  HANDLE h=g_RuntimeVars.vm->LoadBridge(L"DotNET_Bridge_ThroughVC.dll",NULL);

  dValue path,ret;
  path=L"CSharpUI.dll";
  dobject dotnet=g_RuntimeVars.env->GetSharedObject(L"DotNET_Bridge");
  dotnet->Invoke((dobject)NULL,L"LoadDotNETLibrary",&path,&ret);

  TestProc();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  SimpleRelease_dvm();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
  AnsiString s=GetCurrentDir();
  HANDLE h=g_RuntimeVars.vm->LoadBridge(L"php_dsRE.dll",NULL);
}
//---------------------------------------------------------------------------

DEFINE_DSRE_FUNCTION(TForm1,Rectangle)//sample:f(dMethod *method,dobject sender,pAutoArg args,dValue *ret_val)
{
  Caption="fff";
}

BEGIN_DSRE_POPULAR_OBJECT(TForm1)
	DEFINE_POPULAR_METHOD(TForm1,Rectangle);
END_DSRE_POPULAR_OBJECT()g_impl;

dobject CreateObjectByInstance(dFactory *factory,dchararray cls_name,void *local_inst)
{
  dobject dobj=NULL;
  if(wcscmp(L"theCppDialog",cls_name)==0)
  {
    CreatePopularObjectNoClone(factory,cls_name,TForm1,Form1);//MUST set local_inst to g_Dialog, then g_impl->inst==g_Dialog
  }
  return dobj;
}


void __fastcall TForm1::BitBtn6Click(TObject *Sender)
{
	dValue empty;
	dobject this_window=g_RuntimeVars.env->NewDefaultObject((dobject)g_RuntimeVars.factory,L"theCppDialog",&empty);
	g_RuntimeVars.factory->Share((dobject)g_RuntimeVars.factory,this_window,L"theCppDialog");
}
//---------------------------------------------------------------------------

