#include "dni.h"
#include "GlobalFunc.h"

RuntimeVars_t g_RuntimeVars={0,0,0};
dchararray g_VM_Param=NULL;

dobject CreateObjectByInstance(dFactory *factory,dchararray cls_name,void *local_inst);

dobject dcall FindClass
  (dFactory *factory,dchararray cls_name)
{
  dobject dobj=factory->IsClass(cls_name);
  if(dobj==NULL)
  {
    dobj=CreateObjectByInstance(factory,cls_name,NULL);
    if(dobj)
      factory->AddClass(cls_name,dobj);
  }
  return dobj;
}

dobject dcall WrapExistsInstance
	(dFactory *factory,dchararray cls_name,void *local_object)
{
	if(local_object)
	{
		dobject dobj=CreateObjectByInstance(factory,cls_name,local_object);
    if(dobj)
    {
      dobj->flags|=OF_CREATE_SUCCESS;

      dAutoArg args;
      dValue ret;
      dValue temp;
      args<<&temp<<&temp<<&temp<<&temp;
      dobj->Invoke((dobject)factory,L"_Constructor",&args,&ret);

      dobj->flags|=OF_CONSTRUCT_SUCCESS;
    }
    return dobj;
  }
  return NULL;
}

void __stdcall DispatchMsgFunc(void *msg)
{
	if(MainThreadID==GetCurrentThreadId())
	{
		::CheckSynchronize();
	}
}

#ifdef __cplusplus
extern "C" {
#endif

__declspec(dllexport) BOOL
dcall SetDefaultVM(dVM *vm,dEnv *env,dFactory *,dchararray param)
{
  if(vm->LoadBridge(L"VCL_Bridge.dll",L"")==0)
    return FALSE;

  g_VM_Param=param;
  g_RuntimeVars.vm=vm;
  g_RuntimeVars.env=env;

  dFactory *factory=env->CreateFactory();
  wcscpy(factory->cls_name,L"BCBUI");

  g_RuntimeVars.factory=factory;
  g_RuntimeVars.factory->functions->FindClass=FindClass;
  g_RuntimeVars.factory->functions->WrapExistsInstance=WrapExistsInstance;

  vm->RegDispFunc(DispatchMsgFunc);

	return TRUE;
}

#ifdef __cplusplus
}
#endif

BOOL WINAPI DllMain(HINSTANCE h, DWORD reason, LPVOID lpvReserved)
{
	if(reason==DLL_PROCESS_ATTACH)
	{
    DWORD id=GetCurrentThreadId();
		HInstance=h;
		Application->CreateHandle();
	}
	return 1;
}

