unit Delphi_Export;
interface

uses
  Windows,
  dVM,
  DelphiForm;

implementation

function CreateInstance(cls_name :PWideChar): Pointer;stdcall;
begin
  Result := nil;
  //support custom classes
  if cls_name='DelphiForm' then
  begin
     //create a instance of your class
     fDelphiForm := TfDelphiForm.Create(nil);
     //shell to a dobject
     fDelphiForm.Shelled_dobject := g_dvm.ShellExistsInstance(cls_name,fDelphiForm);//return dobject pointer

     fDelphiForm._Create();

     //return the shelled dobject
     Result := fDelphiForm.Shelled_dobject;
  end;
end;

function DestroyInstance(cls_name :PWideChar;inst:Pointer): Pointer;stdcall;
var
 t_fDelphiForm :TfDelphiForm;
begin
  Result := nil;
  //support custom classes
  if cls_name='DelphiForm' then
  begin
     //create a instance of your class
     t_fDelphiForm := inst;
     t_fDelphiForm.Destroy();
  end;
end;

function SetDefaultVM(vm :Pointer; env :Pointer; factory :Pointer; param :Pointer): Boolean; stdcall;
var
  pCreateDelphiFactory: function (vm :Pointer; env :Pointer; param :PWideChar; fpCreate :fCreateInstance; fpDestory :fDestroyInstance): Pointer;stdcall;
  LTempStr: string;
  i: integer;
begin
  Factory := nil;
  Result := False;
  g_dvm := TdVM.Create();
  g_dvm.Load(vm,env,factory,param);
  g_dvm.VCL_DLL := LoadLibrary('VCL_Bridge.dll');
  if g_dvm.VCL_DLL <> 0 then
  begin
    pCreateDelphiFactory := GetProcAddress(g_dvm.VCL_DLL, 'CreateDelphiFactory');
    g_dvm.pShellExistsInstance := GetProcAddress(g_dvm.VCL_DLL, 'Delphi_ShellExistsInstance');
    g_dvm.pRegistDelphiMethod := GetProcAddress(g_dvm.VCL_DLL, 'RegistDelphiMethod');
    if Assigned(pCreateDelphiFactory) and Assigned(g_dvm.pShellExistsInstance) and Assigned(g_dvm.pRegistDelphiMethod) then
    begin
      g_dvm.pFactory := pCreateDelphiFactory(vm,env,param,CreateInstance,DestroyInstance);
      Result := True;
    end;

    g_dvm.Load(vm,env,g_dvm.pFactory,param);
  end;
end;

exports SetDefaultVM;

end.
