// Copyright (c) Luodiping 2006
// Use & modify as you want & need, and leave those 3 lines.
// http://duceland.com

unit dVM;

interface

uses
  Windows;

  type FSynchronizationCaller = function (sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar of object;stdcall;

  type fS_CreateVM = function (): PWideChar; stdcall;
  type fS_ReleaseVM = function (): PWideChar; stdcall;
  type fSetDefaultVM = function(vm :Pointer; env :Pointer; factory :Pointer; param :Pointer): Boolean; stdcall;
  type fS_DelegatedStdcall = function(delegated_obj: PWideChar; method_name: PWideChar; param: PWideChar; flag: Integer; receiver_this: Pointer;receiver_fp: Pointer): PWideChar; stdcall;
  type fS_LoadBridge = function(dll_file: PWideChar; param: PWideChar): THandle; stdcall;
  type fS_DefaultNewObject = function(cls_name: PWideChar; param: PWideChar): PWideChar; stdcall;
  type fS_ShareExists = function(cls_name: PWideChar;be_shared_native_obj: Pointer;share_name: PWideChar): PWideChar; stdcall;
  type fS_GetSharedObject = function(shared_name: PWideChar): PWideChar; stdcall;
  type fS_Invoke = function(ssender: PWideChar; shost: PWideChar; method_name: PWideChar; sparam: PWideChar): PWideChar; stdcall;
  type fS_GetField = function(shost: PWideChar; field_name: PWideChar): PWideChar; stdcall;
  type fS_SetField = function(shost: PWideChar; field_name: PWideChar; value: PWideChar): PWideChar; stdcall;

  type fCreateInstance = function (cls_name :PWideChar): Pointer; stdcall;
  type fDestroyInstance = function (cls_name :PWideChar;inst :Pointer): Pointer; stdcall;
  type fRegistDelphiMethod = function (factory: Pointer;sender: Pointer;receiver: Pointer;method: Pointer;flag: Integer;fp: Pointer;method_name: PWideChar;param: PWideChar;ret_vt: Integer): Pointer; stdcall;
  type fShellExistsInstance = function (factory: Pointer;cls_name: PWideChar;local_object: Pointer): Pointer; stdcall;

  type fGetGlobalVMPointer = function(): Pointer; stdcall;
  type fGetGlobalEnvPointer = function(): Pointer; stdcall;
  type fGetLastFactoryPointer = function(): Pointer; stdcall;
type
  TdVM = class
    constructor Create();
    destructor  Destroy(); override;
  public
    dsRE_DLL: HModule;
    IsBuild: Boolean;

    S_CreateVM: fS_CreateVM;
    S_ReleaseVM: fS_ReleaseVM;
    S_SetDefaultVM: fSetDefaultVM;
    S_DelegatedStdcall: fS_DelegatedStdcall;
    S_LoadBridge: fS_LoadBridge;
    S_DefaultNewObject: fS_DefaultNewObject;
    S_ShareExists: fS_ShareExists;
    S_GetSharedObject: fS_GetSharedObject;
    S_Invoke: fS_Invoke;
    S_GetField: fS_GetField;
    S_SetField: fS_SetField;

    VCL_DLL: HModule;
    pFactory: Pointer;
    pCreateInstance :fCreateInstance;
    pShellExistsInstance :fShellExistsInstance;
    pRegistDelphiMethod :fRegistDelphiMethod;

    S_GetGlobalVMPointer: fGetGlobalVMPointer;
    S_GetGlobalEnvPointer: fGetGlobalEnvPointer;
    S_GetLastFactoryPointer: fGetLastFactoryPointer;
  private
    function SetDefaultVM(vm :Pointer; env :Pointer; factory :Pointer; param :Pointer): Boolean;
  public
    function DelegatedStdcall(delegated_obj: PWideChar; method_name: PWideChar; param: PWideChar; flag: Integer; receiver_this: Pointer;receiver_fp: FSynchronizationCaller) :PWideChar;
    function LoadBridge(dll_file: PWideChar; param: PWideChar): THandle;
    function DefaultNewObject(cls_name: PWideChar; param: PWideChar): PWideChar;
    function ShareExists(cls_name: PWideChar;be_shared_native_obj: Pointer;share_name: PWideChar): PWideChar;
    function GetSharedObject(shared_name: PWideChar): PWideChar;
    function Invoke(ssender: PWideChar; shost: PWideChar; method_name: PWideChar; sparam: PWideChar): PWideChar;
    function GetField(shost: PWideChar; field_name: PWideChar): PWideChar;
    function SetField(shost: PWideChar; field_name: PWideChar; value: PWideChar): PWideChar;

    function RegistDelphiMethod(sender: Pointer;receiver: Pointer;method: Pointer;flag: Integer;fp: FSynchronizationCaller;method_name: PWideChar;param: PWideChar;ret_vt: Integer): Pointer;
    function ShellExistsInstance(cls_name: PWideChar;local_object: Pointer): Pointer;

    function GetGlobalVMPointer(): Pointer;
    function GetGlobalEnvPointer(): Pointer;
    function GetLastFactoryPointer(): Pointer;
  public
    procedure Build();
    procedure Load(vm: Pointer; env: Pointer; factory: Pointer; param: Pointer);
  end;

var
  g_dvm: TdVM;

implementation

constructor TdVM.Create();
begin
  IsBuild := False;

  dsRE_DLL := LoadLibrary('dsRE.dll');
  @S_CreateVM := GetProcAddress(dsRE_DLL, 'S_CreateVM');
  @S_ReleaseVM := GetProcAddress(dsRE_DLL, 'S_ReleaseVM');
  @S_SetDefaultVM := GetProcAddress(dsRE_DLL, 'SetDefaultVM');
  @S_DelegatedStdcall := GetProcAddress(dsRE_DLL, 'S_DelegatedStdcall');
  @S_LoadBridge := GetProcAddress(dsRE_DLL, 'S_LoadBridge');
  @S_DefaultNewObject := GetProcAddress(dsRE_DLL, 'S_DefaultNewObject');
  @S_ShareExists := GetProcAddress(dsRE_DLL, 'S_ShareExists');
  @S_GetSharedObject := GetProcAddress(dsRE_DLL, 'S_GetSharedObject');
  @S_Invoke := GetProcAddress(dsRE_DLL, 'S_Invoke');
  @S_GetField := GetProcAddress(dsRE_DLL, 'S_GetField');
  @S_SetField := GetProcAddress(dsRE_DLL, 'S_SetField');

  @S_GetGlobalVMPointer := GetProcAddress(dsRE_DLL, 'GetGlobalVMPointer');
  @S_GetGlobalEnvPointer := GetProcAddress(dsRE_DLL, 'GetGlobalEnvPointer');
  @S_GetLastFactoryPointer := GetProcAddress(dsRE_DLL, 'GetLastFactoryPointer');
end;

procedure TdVM.Build();
begin
  IsBuild := True;
  S_CreateVM();
end;
procedure TdVM.Load(vm: Pointer; env: Pointer; factory: Pointer; param: Pointer);
begin
  IsBuild := False;
  S_SetDefaultVM(vm,env,factory,param);
end;

destructor TdVM.Destroy();
begin
  if IsBuild then
    S_ReleaseVM();

  FreeLibrary(dsRE_DLL);
end;

function TdVM.SetDefaultVM(vm :Pointer; env :Pointer; factory :Pointer; param :Pointer): Boolean;
begin
  Result := S_SetDefaultVM(vm,env,factory,param);
end;
function TdVM.DelegatedStdcall(delegated_obj: PWideChar; method_name: PWideChar; param: PWideChar; flag: Integer; receiver_this: Pointer;receiver_fp: FSynchronizationCaller): PWideChar;
var
  fp:Pointer;
begin
  fp := @receiver_fp;
  Result  := S_DelegatedStdcall(delegated_obj, method_name, param, flag, receiver_this, fp);
end;

function TdVM.LoadBridge(dll_file: PWideChar; param: PWideChar): THandle;
begin
  Result  := S_LoadBridge(dll_file,param);
end;

function TdVM.DefaultNewObject(cls_name: PWideChar; param: PWideChar): PWideChar;
begin
  Result  := S_DefaultNewObject(cls_name,param);
end;

function TdVM.ShareExists(cls_name: PWideChar;be_shared_native_obj: Pointer;share_name: PWideChar): PWideChar;
begin
  Result  := S_ShareExists(cls_name,be_shared_native_obj,share_name);
end;

function TdVM.GetSharedObject(shared_name: PWideChar): PWideChar;
begin
  Result  := S_GetSharedObject(shared_name);
end;

function TdVM.Invoke(ssender: PWideChar; shost: PWideChar; method_name: PWideChar; sparam: PWideChar): PWideChar;
begin
  Result  := S_Invoke(ssender,shost,method_name,sparam);
end;

function TdVM.GetField(shost: PWideChar; field_name: PWideChar): PWideChar;
begin
  Result  := S_GetField(shost,field_name);
end;

function TdVM.SetField(shost: PWideChar; field_name: PWideChar; value: PWideChar): PWideChar;
begin
  Result  := S_SetField(shost,field_name,value);
end;

function TdVM.RegistDelphiMethod(sender: Pointer;receiver: Pointer;method: Pointer;flag: Integer;fp: FSynchronizationCaller;method_name: PWideChar;param: PWideChar;ret_vt: Integer): Pointer;
var
  p :Pointer;
begin
  p := @fp;
  Result := pRegistDelphiMethod(pFactory,sender,receiver,method,flag,p,method_name,param,ret_vt);
end;

function TdVM.ShellExistsInstance(cls_name: PWideChar;local_object: Pointer): Pointer;
begin
  Result := pShellExistsInstance(pFactory,cls_name,local_object);
end;

function TdVM.GetGlobalVMPointer(): Pointer;
begin
  Result := S_GetGlobalVMPointer();
end;

function TdVM.GetGlobalEnvPointer(): Pointer;
begin
  Result := S_GetGlobalEnvPointer();
end;

function TdVM.GetLastFactoryPointer(): Pointer;
begin
  Result := S_GetLastFactoryPointer();
end;

end.
