using System;
using System.Text;
using System.Runtime.InteropServices;

public class dobject
{
	public string ObjectLabel;
	public dobject(string obj_label)
	{
		ObjectLabel=obj_label;
	}
	public dobject Invoke(dobject sender,string method_name,string param)
	{
		string sender_label;
		if(sender==null)
			sender_label="";
		else
			sender_label=sender.ObjectLabel;
		return new dobject(dVM.S_Invoke(sender_label,this.ObjectLabel,method_name,param));
	}
	public dobject Invoke(string method_name,string param)
	{
		return new dobject(dVM.S_Invoke("obj_0",this.ObjectLabel,method_name,param));
	}
	public dobject GetField(string field_name)
	{
		return new dobject(dVM.S_GetField(ObjectLabel,field_name));
	}
	public void SetField(string field_name,dobject Value)
	{
		string sender_label;
		if(Value==null)
			sender_label="";
		else
			sender_label=Value.ObjectLabel;
		dVM.S_SetField(this.ObjectLabel,field_name,sender_label);
	}

	public void SetField(string field_name,string Value)
	{
		dVM.S_SetField(this.ObjectLabel,field_name,Value);
	}

	public override string ToString()
	{
		return ObjectLabel;
	}
}

public class dVM
{
	#region functions of dsRE.dll
	[DllImport("dsRE.dll")]
	private extern static IntPtr S_CreateVM();

	[DllImport("dsRE.dll")]
	private extern static void S_ReleaseVM();
	public void ReleaseVM()
	{
		S_ReleaseVM();
	}

	[DllImport("dsRE.dll")]
	private extern static IntPtr GetGlobalVMPointer();
	#endregion

	#region functions of DotNET_Bridge.dll
	[DllImport("DotNET_Bridge.dll")]
	private extern static IntPtr S_LoadBridge(IntPtr vm,string dll_file,string param);
	public IntPtr LoadBridge(string dll_file,string param)
	{
		return S_LoadBridge(vm,dll_file,param);
	}

	[DllImport("DotNET_Bridge.dll")]
	private extern static IntPtr ShareExists(string cls_name,Object be_shared_local_obj,String share_name);
	public dobject ShareExistsObject(string cls_name,Object be_shared_local_obj,String share_name)
	{
		return new dobject(Marshal.PtrToStringAuto(ShareExists(cls_name,be_shared_local_obj,share_name)));
	}

	[DllImport("DotNET_Bridge.dll")]
	private extern static string S_DefaultNewObject(string cls_name,string param);
	public dobject DefaultNewObject(string cls_name,string param)
	{
		return new dobject(S_DefaultNewObject(cls_name,param));
	}

	[DllImport("DotNET_Bridge.dll")]
	private extern static string S_GetSharedObject(string shared_name);
	public dobject GetSharedObject(string shared_name)
	{
		return new dobject(S_GetSharedObject(shared_name));
	}

	[DllImport("DotNET_Bridge.dll")]
	public extern static string S_Invoke(string ssender,string shost,string method_name,string param);


	[DllImport("DotNET_Bridge.dll")]
	public extern static string S_GetField(string shost,string field_name);

	[DllImport("DotNET_Bridge.dll")]
	public extern static void S_SetField(string shost,string field_name,string Value);

	[DllImport("DotNET_Bridge.dll")]
	private extern static void S_DelegatedStdcall(string delegated_obj,string method_name,string param,int flag,Object receiver_this,string receiver_func);
	public void DelegatedStdcall(dobject delegated_obj,string method_name,string param,int flag,Object receiver_this,string receiver_func)
	{
		S_DelegatedStdcall(delegated_obj.ObjectLabel,method_name,param,flag,receiver_this,receiver_func);
	}
	#endregion

	private IntPtr vm;
	public dVM()
	{
		vm=GetGlobalVMPointer();
		if(vm==IntPtr.Zero)
		{
			S_CreateVM();
			vm=GetGlobalVMPointer();
		}
		S_LoadBridge(vm,"DotNET_Bridge_ThroughVC.dll","");
		dvm=this;
	}
	~dVM()
	{
		ReleaseVM();
	}
	public static dVM dvm;

	#region functions of string
	public static string FormatString(string s)
	{
		string ret="\"";
		ret+=s.Replace("\"","\\\"");
		ret+="\"";
		return ret;
	}
	#endregion
}
