// Copyright (c) Luodiping 2006
// http://duceland.com

#ifndef __DNI_H__
#define __DNI_H__

#ifdef __DLL__
# define DLLIMPORT __declspec(dllexport)
#else /* Not DLL */
# define DLLIMPORT __declspec(dllimport)
#endif

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <map>
#include <list>
#include <vector>
#include <string>
#ifdef __GNUC__
#include <typeinfo>
#else
#include <typeinfo.h>
#endif

#include "dtypes.h"

//[published declear- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#define dcall __stdcall

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#pragma pack(4)

#define NORMAL_DS_OBJECT_HEADER \
    dobject base;               /*base class pointer     */   \
    dFactory *factory;          /*point to factory back  */   \
    dint _RefCount;             /*reference count        */   \
    dint _cbSize;               /*size of me             */   \
    unsigned int flags;         /*object property flags  */   \
    void *WndHandle;            /*window handle,for dEnv->SetViewParent() to set across lib window's relation */ \
    unsigned int id;            /*when create object, RE assign a id to it */ \
    dchar cls_name[64];         /*class name */ \
    dint native_inst_level;     /*level of local instance*/ \
                                                            \
    void *SystemReserved[15]   /*reserved data for system */

#define NORMAL_DS_OBJECT_FUNC_DATA \
  struct dynamic_functions_t                                                             \
  {                                                                                      \
    dint _cbCount;                                                                       \
    dMethod _Create;                                                                     \
    dMethod _Release;                                                                    \
    dMethod _Constructor;                                                                \
    dMethod _Destructor;                                                                 \
  }* df;                                                                                 \
                                                                                         \
  struct Data{                                                                           \
    dint _cbCount;                                                                       \
    dField _Field0[1];                                                                   \
  }* data;

#define get_dobject_native_inst(obj)                          \
    ((obj==NULL)?NULL:(obj->native_inst_level==0)?            \
      obj->inst:                                             \
    (obj->inst==NULL?NULL:(obj->native_inst_level==1)?        \
      obj->inst->inst:                                       \
    (obj->inst->inst==NULL?NULL:(obj->native_inst_level==2)?  \
      obj->inst->inst->inst:NULL)))

#define get_dvalue_native_inst(dvalue)                        \
    ((dvalue.vt==vt_lobject)?                                \
    dvalue.o.o:get_dobject_native_inst(dvalue.o.o))

#define get_dvalue_native_inst_p(dvalue)                      \
    ((dvalue->vt==vt_lobject)?                               \
    dvalue->o.o:get_dobject_native_inst(dvalue->o.o))

struct dFactory;
struct _dobject
{
  dobject inst;               //instance of local language
  NORMAL_DS_OBJECT_HEADER;

  struct dynamic_functions_t  //dynamic method/event void *reserved3;
  {
    dint _cbCount;            //method count
    dMethod _Method0[1];      //methods

    //{{custom public functions
    /*
    //{these 4 functions must be declared
    dMethod _Create;//real arguments:(dchararay name,other params)
    dMethod _Release;
    dMethod _Constructor;
    dMethod _Destructor;
    //these 4 functions must be declared}
    */
    //custom public functions}}
  }* df;

  //member data
  struct Data{
    dint _cbCount;            //field count
    dField _Field0[1];        // point to first field
  }* data;

  void *CustomReserved[24];//reserved data for custom

  //published functions - dobject standard
  inline void dcall Destroy
      ();
  inline void dcall Invoke
    (dobject sender,dchararray func_name,pAutoArg args,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue *ret_val);

  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *v3,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *v3,dValue *v4,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *v3,dValue *v4,dValue *v5,dValue *ret_val);

  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue v3,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue v3,dValue v4,dValue *ret_val);
  inline void dcall Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue v3,dValue v4,dValue v5,dValue *ret_val);

  inline void dcall Invoke
    (dobject sender,dMethod *method);
  inline void dcall Invoke
    (dobject sender,dMethod *method,pAutoArg args,dValue *ret_val);
  inline void dcall SetField
    (dField *field,dchararray field_name,dValue *value);
  inline void dcall SetField
      (dField *field,dchararray field_name,dValue value);
  inline void dcall GetField
      (dField *field,dchararray field_name,dValue *ret_val);
  inline void dcall RegistMethod
      (dobject receiver,dMethod *method,dint flag,void *fp,dchararray func_name,dchararray param,dint ret_vt,void *data[]=NULL);
};

//{define object flags, above 0x1000000 is custom flags
#define OF_NONE                0
//register to delete by vm, but not destoried
#define OF_DELETED             0x000001
//dont delete inst on _Destructor()
#define OF_DONT_DEL_INST       0x000002
//the object call _Create() success
#define OF_CREATE_SUCCESS      0x000004
//the object call _Constructor() success
#define OF_CONSTRUCT_SUCCESS   0x000008
//the object this->inst point to local object instance
#define OF_INST_POINT_TO_LOCAL 0x000010
//the object is a factory
#define OF_FACTORY             0x000020
//the object is thread safe
#define OF_THREAD_SAFE         0x000040
//a shadow object
#define OF_SHADOW              0x100000
//the object is a factory but create shadow
#define OF_SHADOW_FACTORY      0x200000

struct dEnv;
struct dFactory
{
  dobject inst;               //instance of local language
  NORMAL_DS_OBJECT_HEADER;

  struct functions_t
  {
    //type custom public functions
    dbool (dcall *AddClass)
      (dFactory *factory,dchararray name,dobject cls);
    dobject (dcall *IsClass)
      (dFactory *factory,dchararray name);
    dobject (dcall *FindClass)
      (dFactory *factory,dchararray name);
    dobject (dcall *CreateObject)
      (dFactory *factory,dobject owner_obj,dobject cls);
		dobject (dcall *WrapExistsInstance)
			(dFactory *factory,dchararray cls_name,void *local_object);
    dbool (dcall *DestroyObject)
      (dFactory *factory,dobject obj,dchararray name);
    dbool (dcall *Inherit)
      (dFactory *factory,dobject inherit_obj,dobject inherited_obj);

    void (dcall *RegistMethod)
      (dFactory *factory,dobject sender,dobject receiver,dMethod *method,dint flag,void *fp,dchararray func_name,dchararray param,dint ret_vt,void *data[]);
    dMethod *(dcall *FindMethod)
      (dFactory *factory,dobject host,dchararray func_name,dchararray param);
    dMethod *(dcall *FindMethodA)
      (dFactory *factory,dobject host,dchararray func_name,pAutoArg args);

    void (dcall *RegistField)
      (dFactory *factory,dobject host,dField *field,dMethod *get_method,dMethod *set_method,dchararray field_name,dchararray td,dint member_vt);
    void (dcall *SetField)
      (dFactory *factory,dobject host,dField *field,dchararray field_name,dValue *value);
    void (dcall *GetField)
      (dFactory *factory,dobject host,dField *field,dchararray field_name,dValue *ret_val);
    dField *(dcall *FindField)
      (dFactory *factory,dobject host,dchararray field_name);

    //mantian object tree
    dbool (dcall *AddChild)
      (dFactory *factory,dobject parent,dobject child);
    void (dcall *LeaveChild)
      (dFactory *factory,dobject parent,dobject child);

    //share object to other part
    void (dcall *Share)
      (dFactory *factory,dobject parent,dobject obj,dchararray share_name);
    void (dcall *Unshare)
      (dFactory *factory,dobject parent,dchararray shared_name);
    dobject (dcall *GetSharedObject)
      (dFactory *factory,dchararray shared_name);
  }* functions;

  struct Data{
    dbool Created;
  }* m;

  //published functions - factory data
  dEnv *env;
  void *HookObject;

  void *CustomReserved[22];//reserved data for custom

  inline dbool dcall AddClass
      (dchararray name,dobject cls)
  {
    return functions->AddClass(this,name,cls);
  }
  inline dobject dcall IsClass
      (dchararray name)
  {
    return functions->IsClass(this,name);
  }
  inline dobject dcall FindClass
      (dchararray name)
  {
    return functions->FindClass(this,name);
  }
  inline dobject dcall CreateObject
    (dobject owner_obj,dobject cls)
  {
    return functions->CreateObject(this,owner_obj,cls);
  }
	inline dobject dcall WrapExistsInstance
		(dchararray cls_name,void *local_object)
	{
		return functions->WrapExistsInstance(this,cls_name,local_object);
  }
  inline dbool dcall DestroyObject
    (dobject obj,dchararray name)
  {
    return functions->DestroyObject(this,obj,name);
  }

  //Inherit object from other
  inline dbool dcall Inherit
    (dobject inherit_obj,dobject inherited_obj)
  {
    return functions->Inherit(this,inherit_obj,inherited_obj);
  }
  inline void dcall RegistMethod
      (dobject sender,dobject receiver,dMethod *method,dint flag,void *fp,dchararray func_name,dchararray param,dint ret_vt,void *data[]=NULL)
  {
    functions->RegistMethod(this,sender,receiver,method,flag,fp,func_name,param,ret_vt,data);
  }
  inline void dcall RegistMethod
      (dobject sender,dobject receiver,dMethod *method,dint flag,void *fp,dchararray func_name,const char* param,dint ret_vt,void *data[]=NULL)
  {
    wchar_t w[300];
    MultiBytesToWides(w,param,strlen(param));
    functions->RegistMethod(this,sender,receiver,method,flag,fp,func_name,w,ret_vt,data);
  }
  dMethod * dcall FindMethod
    (dobject host,dchararray func_name,dchararray param)
  {
    return functions->FindMethod(this,host,func_name,param);
  }
  dMethod * dcall FindMethodA
    (dobject host,dchararray func_name,pAutoArg args)
  {
    return functions->FindMethodA(this,host,func_name,args);
  }
  inline void dcall RegistField
      (dobject host,dField *field,dMethod *get_method,dMethod *set_method,dchararray field_name,dchararray td,dint field_vt)
  {
    functions->RegistField(this,host,field,get_method,set_method,field_name,td,field_vt);
  }
  inline void dcall SetField
      (dobject host,dField *field,dchararray field_name,dValue value)
  {
    functions->SetField(this,host,field,field_name,&value);
  }
  inline void dcall SetField
      (dobject host,dField *field,dchararray field_name,dValue *value)
  {
    functions->SetField(this,host,field,field_name,value);
  }
  inline void dcall GetField
      (dobject host,dField *field,dchararray field_name,dValue *ret_val)
  {
    functions->GetField(this,host,field,field_name,ret_val);
  }
  inline dField *dcall FindField
      (dobject host,dchararray field_name)
  {
    return functions->FindField(this,host,field_name);
  }

  //mantian object tree
  inline dbool dcall AddChild
      (dobject parent,dobject child)
  {
    return functions->AddChild(this,parent,child);
  }
  inline void dcall LeaveChild
      (dobject parent,dobject child)
  {
    functions->LeaveChild(this,parent,child);
  }

  //share object to other part
  inline void dcall Share
      (dobject parent,dobject obj,dchararray share_name)
  {
    functions->Share(this,parent,obj,share_name);
  }
  inline void dcall Unshare
      (dobject parent,dchararray shared_name)
  {
    functions->Unshare(this,parent,shared_name);
  }
  inline dobject dcall GetSharedObject
      (dchararray shared_name)
  {
    return functions->GetSharedObject(this,shared_name);
  }

  //local called functions
  dobject dcall Create(dchararray name);
  void dcall Release(dchararray name);
};

struct dVM;
struct dEnv{
  void *reserved0;
  void *reserved1;
  void *reserved2;
  void *reserved3;
  dbool Created;

  struct functions_t
  {
    //create default functional factory
    dFactory *(dcall *CreateFactory)
      (dEnv* env);

    //find class by name
    dobject (dcall *FindClass)
      (dEnv *env,dchararray name);

    //class a object by cls of class
    dobject (dcall *CreateObject)
      (dEnv *env,dobject owner_obj,dobject cls);

    //call a member function
    void (dcall *Invoke)
      (dEnv* env,dFactory* factory,dobject host,dobject sender,dMethod *method,dint flag,dchararray func_name,pAutoArg args,dValue *ret_val);

    //new a object using now class
    dobject (dcall *NewDefaultObject)
      (dEnv *env,dobject owner_obj,dchararray name,pAutoArg args);

    //create a local object's dobject shell
		dobject (dcall *WrapExistsInstance)
      (dEnv *env,dchararray cls_name,void *local_object);

    //destroy object.But not delete inmadiatly
    dbool (dcall *DestroyObject)
      (dEnv *env,dobject obj,dchararray name);

    //the reserved functions
    struct{
      void *Reserve[15];
    }Reserved0;

    void (dcall *SetMainWndHandle)//must main process call it
      (dEnv* env,void *hMainWndHandle);

    //at Windows, SetParent(HWND,HWND) be called
    void (dcall *SetViewParent)
      (dEnv* env,dobject parent,dobject child,dint flags);

    //for share
    dobject (dcall *GetSharedObject)
      (dEnv* env,dchararray shared_name);

    //translate between object pointer and label
    void (dcall *Object2Label)
      (dEnv* env,dobject obj,dchararray label);
    dobject (dcall *Label2Object)
      (dEnv* env,dchararray label);

  }* functions;

  dVM *vm;
  void *MainWndHandle;
  dint MainThreadId;
  dint MainProcessId;
  void *ThreadSafePointer;//for php tsrm_ls

  void *Reserved[24];//reserved data

  //published functions

  inline dFactory* dcall CreateFactory
    ()
  {
    return functions->CreateFactory(this);
  }
  inline dobject dcall FindClass
      (dchararray name)
  {
    return functions->FindClass(this,name);
  }
  inline dobject dcall CreateObject
      (dobject owner_obj,dobject cls)
  {
    return functions->CreateObject(this,owner_obj,cls);
  }
  inline dobject dcall NewDefaultObject
      (dobject owner_obj,dchararray name,pAutoArg args)
  {
    return functions->NewDefaultObject(this,owner_obj,name,args);
  }
  inline dobject dcall NewDefaultObject
      (dobject owner_obj,dchararray name,dValue *v1)
  {
    dAutoArg args;
    args<<v1;
    return functions->NewDefaultObject(this,owner_obj,name,&args);
  }
  inline dobject dcall NewDefaultObject
      (dobject owner_obj,dchararray name,dValue *v1,dValue *v2)
  {
    dAutoArg args;
    args<<v1<<v2;
    return functions->NewDefaultObject(this,owner_obj,name,&args);
  }
  inline dobject dcall WrapExistsInstance
			(dchararray cls_name,void *local_object)
  {
		return functions->WrapExistsInstance(this,cls_name,local_object);
  }
  inline dbool dcall DestroyObject
      (dobject obj,dchararray name)
  {
    return functions->DestroyObject(this,obj,name);
  }
  inline void dcall Invoke
      (dFactory* factory,dobject host,dobject sender,dMethod *method,dint flag,dchararray func_name,pAutoArg args,dValue *ret_val)
  {
    functions->Invoke(this,factory,host,sender,method,flag,func_name,args,ret_val);
  }

  inline void dcall SetMainWndHandle//must main process call it
    (void *hMainWndHandle)
  {
    functions->SetMainWndHandle(this,hMainWndHandle);
  }
  //at Windows, SetParent(WND,WND) be called
  inline void dcall SetViewParent
    (dobject parent,dobject child,dint flags)
  {
    functions->SetViewParent(this,parent,child,flags);
  }

  //for share
  inline dobject dcall GetSharedObject
    (dchararray shared_name)
  {
    return functions->GetSharedObject(this,shared_name);
  }

  //translate between object pointer and label
  void dcall Object2Label
    (dobject obj,dchararray label)
  {
    functions->Object2Label(this,obj,label);
  }
  dobject dcall Label2Object
    (dchararray label)
  {
    return functions->Label2Object(this,label);
  }

  //local called functions
  dobject dcall Create(dchararray name);
  void dcall Release(dchararray name);
};

class CWinApp;
class CWnd;
class CView;

struct dVM{
  void *reserved0;
  void *reserved1;
  void *reserved2;
  void *reserved3;

  struct functions_t
  {
    //type custom public functions
    dbool (dcall *GetDefaultEnv)
        (dVM *vm,dEnv **env);
    void* (dcall *LoadBridge)
        (dVM *vm,dchararray lib_file,dchararray param);

    //memory manager
    void *(dcall *Alloc)
      (dVM *vm,dobject owner_obj,dsize size);
    void (dcall *Unalloc)
      (dVM *vm,dobject owner_obj,void *p);
    void (dcall *Free)
      (dVM *vm,dobject owner_obj,void *p);
    dobject (dcall *AllocObject)
      (dVM *vm,dobject owner_obj,dint size);
    void (dcall *UnallocObject)
      (dVM *vm,dobject owner_obj,dobject obj);
    void (dcall *FreeObject)
      (dVM *vm,dobject owner_obj,dobject obj);

    LWideString *(dcall *AllocString)
      (dVM *vm,dobject owner_obj);
    dchararray (dcall *ReallocStringData)
      (dVM *vm,LWideString *str,int data_len);
    void (dcall *UnallocString)
      (dVM *vm,dobject owner_obj,LWideString *w);
    void (dcall *FreeString)
      (dVM *vm,dobject owner_obj,LWideString *w);

    //copy method linked list
    void (dcall *CopyMethod)
      (dVM *vm,dobject obj,dMethod *dist,dMethod *source,dField *assigned_field);
    //copy dynamic funcitons
    void (dcall *AllocAndCopyDF)
      (dVM *vm,dobject obj,_dobject::dynamic_functions_t *cls_df);
    //copy fields
    void (dcall *AllocAndCopyData)
      (dVM *vm,dobject obj,_dobject::Data *source_data);

    //regiester dispatch function pointer
    void (dcall *RegDispFunc)
      (dVM *vm,DispatchMsgFunc_t func);
    void (dcall *UnregDispFunc)
      (dVM *vm,DispatchMsgFunc_t func);
    void (dcall *DoDispatch)
      (dVM *vm,void *msg);

    //thread functions
    dobject (dcall *GetCurrentObject)
      (dVM *vm);

    //synchronize & asynchronous
    dobject (dcall *CreateSyncObject)
      (dVM *vm);
    dbool (dcall *WaitSyncObject)
      (dVM *vm,dobject wso);
    void (dcall *PassSyncObject)
      (dVM *vm,dobject wso);
    void (dcall *DestroySyncObject)
      (dVM *vm,dobject wso);

    void (dcall *SynchronizeInvokeStd)
      (dVM *vm,dobject dthis,dMethod *method,dobject sender,void *fp,pAutoArg args,dValue *ret_val);
    void (dcall *SynchronizeInvokeCStyle6P)
      (dVM *vm,void *fp,void *p1,void *p2,void *p3,void *p4,void *p5,void *p6);

    void (dcall *RegistAsynMethodStd)
      (dVM *vm,dobject dthis,dMethod *method,dobject sender,void *fp,pAutoArg args,dValue *ret_val);
    void (dcall *RegistAsynMethodCStyle6P)
      (dVM *vm,void *fp,void *p1,void *p2,void *p3,void *p4,void *p5,void *p6);
    void (dcall *UnregistAsynMethod)
      (dVM *vm,void *fp);
  }* functions;

  struct Data{
    dbool Created;
  }* m;

  //[publish]
  dEnv *DefaultEnv;
  dFactory* factory;//header of factories

  struct{
    CWinApp *App;
    CWnd *MainFrame;
    CView *DefaultView;
  }MfcFrame;//process is a mfc framework

  void *Reserved[26];//reserved data

  //published functions

  inline dbool dcall GetDefaultEnv
        (dEnv **env)
  {
    return functions->GetDefaultEnv(this,env);
  }
  inline void* dcall LoadBridge
        (dchararray lib_file,dchararray param)
  {
    return functions->LoadBridge(this,lib_file,param);
  }

  //memory manager
  inline void *dcall Alloc
      (dobject owner_obj,dsize size)
  {
    return functions->Alloc(this,owner_obj,size);
  }
  inline void dcall Unalloc
      (dobject owner_obj,void *p)
  {
    functions->Unalloc(this,owner_obj,p);
  }
  inline void dcall Free
      (dobject owner_obj,void *p)
  {
    functions->Free(this,owner_obj,p);
  }
  inline dobject dcall AllocObject
      (dobject owner_obj,dint size)
  {
    return functions->AllocObject(this,owner_obj,size);
  }
  inline  void dcall UnallocObject
      (dobject owner_obj,dobject obj)
  {
    functions->UnallocObject(this,owner_obj,obj);
  }
  inline  void dcall FreeObject
      (dobject owner_obj,dobject obj)
  {
    functions->FreeObject(this,owner_obj,obj);
  }

  inline LWideString * dcall AllocString
      (dobject owner_obj)
  {
    return functions->AllocString(this,owner_obj);
  }
  inline dchararray dcall ReallocStringData
      (LWideString *str,int data_len)
  {
    return functions->ReallocStringData(this,str,data_len);
  }
  inline void dcall UnallocString
      (dobject owner_obj,LWideString *w)
  {
    functions->UnallocString(this,owner_obj,w);
  }
  inline void dcall FreeString
      (dobject owner_obj,LWideString *w)
  {
    functions->FreeString(this,owner_obj,w);
  }

  //copy method linked list
  inline void dcall CopyMethod
    (dobject obj,dMethod *dist,dMethod *source,dField *assigned_field=NULL)
  {
    functions->CopyMethod(this,obj,dist,source,assigned_field);
  }
  //copy dynamic funcitons
  inline void dcall AllocAndCopyDF
    (dobject obj,_dobject::dynamic_functions_t *cls_df)
  {
    functions->AllocAndCopyDF(this,obj,cls_df);
  }
  //copy fields
  inline void dcall AllocAndCopyData
    (dobject obj,_dobject::Data *source_data)
  {
    functions->AllocAndCopyData(this,obj,source_data);
  }

  //regiester dispatch function pointer
  inline void dcall RegDispFunc
    (DispatchMsgFunc_t func)
  {
    functions->RegDispFunc(this,func);
  }
  inline void dcall UnregDispFunc
    (DispatchMsgFunc_t func)
  {
    functions->UnregDispFunc(this,func);
  }
  inline void dcall DoDispatch
    (void *msg)
  {
    functions->DoDispatch(this,msg);
  }
  //thread functions
  inline dobject dcall GetCurrentObject
    ()
  {
    return functions->GetCurrentObject(this);
  }

  //synchronize & asynchronous
  dobject dcall CreateSyncObject
      ()
  {
    return functions->CreateSyncObject(this);
  }
  dbool dcall WaitSyncObject
      (dobject wso)
  {
    return functions->WaitSyncObject(this,wso);
  }
  void dcall PassSyncObject
      (dobject wso)
  {
    functions->PassSyncObject(this,wso);
  }
  void dcall DestroySyncObject
      (dobject wso)
  {
    functions->DestroySyncObject(this,wso);
  }

  void dcall SynchronizeInvokeStd
      (dobject dthis,dMethod *method,dobject sender,void *fp,pAutoArg args,dValue *ret_val)
  {
    functions->SynchronizeInvokeStd(this,dthis,method,sender,fp,args,ret_val);
  }
  void dcall SynchronizeInvokeCStyle6P
      (void *fp,void *p1,void *p2,void *p3,void *p4,void *p5,void *p6)
  {
    functions->SynchronizeInvokeCStyle6P(this,fp,p1,p2,p3,p4,p5,p6);
  }
  void dcall RegistAsynMethodStd
      (dobject dthis,dMethod *method,dobject sender,void *fp,pAutoArg args,dValue *ret_val)
  {
    functions->RegistAsynMethodStd(this,dthis,method,sender,fp,args,ret_val);
  }
  void dcall RegistAsynMethodCStyle6P
      (void *fp,void *p1,void *p2,void *p3,void *p4,void *p5,void *p6)
  {
    functions->RegistAsynMethodCStyle6P(this,fp,p1,p2,p3,p4,p5,p6);
  }
  void dcall UnregistAsynMethod
      (void *fp)
  {
    functions->UnregistAsynMethod(this,fp);
  }

  //local called functions
  dobject dcall Create(dchararray name);
  void dcall Release(dchararray name);
};

//some dependent type(s) funcs of dValue here.
struct RuntimeVars_t{
  dVM *vm;
  dEnv *env;
  dFactory *factory;
};
extern RuntimeVars_t g_RuntimeVars;

//dValue some implement
inline dValue& dValue::operator =(const dchararray rhs)
{
  CheckObject(true);
  if(vt!=vt_string || o.s==NULL)
    o.s=g_RuntimeVars.vm->AllocString(NULL);
  *o.s=rhs;
  vt=vt_string;
  return *this;
}
inline void * dValue::AsNativeObject()
{
  if(vt==vt_lobject)
    return o.o;
  if(vt==vt_object)
    return get_dobject_native_inst(o.o);
  return NULL;
}
inline dValue::~dValue()
{
  if(o.s)
    g_RuntimeVars.vm->UnallocString(NULL,o.s);
}
inline void dValue::CheckObject(dbool keep_string)
{
  if(!keep_string)
  {
    if(vt==vt_string)
    {
      g_RuntimeVars.vm->UnallocString(NULL,o.s);
      o.s=NULL;
      vt=vt_unknown;
    }
  }
}
inline void dValue::Ascii2String()//implement in dni.hpp
{
  CheckObject(true);
  if(vt!=vt_string || o.s==NULL)
    o.s=g_RuntimeVars.vm->AllocString(NULL);
  *o.s=v.a;
  vt=vt_string;
}

inline dValue *dValuePointerWrapper::GetValuePointer()
{
  if(vp)
    return vp;
  if(obj)
    return &obj->data->_Field0[field_index].value;
  return &value;
}


inline void dcall _dobject::Destroy
      ()
{
  factory->env->DestroyObject(this,L"");
}
inline void dcall _dobject::Invoke
      (dobject sender,dchararray func_name,pAutoArg args,dValue *ret_val)
{
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,args,ret_val);
}
inline void dcall _dobject::Invoke
      (dobject sender,dchararray func_name)
{
  dAutoArg args;
  dValue ret;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,&ret);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue *ret_val)
{
  dAutoArg args;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}

inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *ret_val)
{
  dAutoArg args;
  args<<v1;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *ret_val)
{
  dAutoArg args;
  args<<v1<<v2;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *v3,dValue *ret_val)
{
  dAutoArg args;
  args<<v1<<v2<<v3;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *v3,dValue *v4,dValue *ret_val)
{
  dAutoArg args;
  args<<v1<<v2<<v3<<v4;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue *v1,dValue *v2,dValue *v3,dValue *v4,dValue *v5,dValue *ret_val)
{
  dAutoArg args;
  args<<v1<<v2<<v3<<v4<<v5;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}

inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue *ret_val)
{
  dAutoArg args;
  args<<&v1;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue *ret_val)
{
  dAutoArg args;
  args<<&v1<<&v2;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue v3,dValue *ret_val)
{
  dAutoArg args;
  args<<&v1<<&v2<<&v3;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue v3,dValue v4,dValue *ret_val)
{
  dAutoArg args;
  args<<&v1<<&v2<<&v3<<&v4;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}
inline void dcall _dobject::Invoke
    (dobject sender,dchararray func_name,dValue v1,dValue v2,dValue v3,dValue v4,dValue v5,dValue *ret_val)
{
  dAutoArg args;
  args<<&v1<<&v2<<&v3<<&v4<<&v5;
  factory->env->Invoke(factory,this,sender,NULL,0,func_name,&args,ret_val);
}

inline void dcall _dobject::Invoke
    (dobject sender,dMethod *method)
{
  dAutoArg args;
  dValue ret;
  factory->env->Invoke(factory,this,sender,method,0,NULL,&args,&ret);
}
inline void dcall _dobject::Invoke
    (dobject sender,dMethod *method,pAutoArg args,dValue *ret_val)
{
  factory->env->Invoke(factory,this,sender,method,0,NULL,args,ret_val);
}
inline void dcall _dobject::SetField
      (dField *field,dchararray field_name,dValue value)
{
  factory->SetField(this,field,field_name,&value);
}
inline void dcall _dobject::SetField
      (dField *field,dchararray field_name,dValue *value)
{
  factory->SetField(this,field,field_name,value);
}
inline void dcall _dobject::GetField
      (dField *field,dchararray field_name,dValue *ret_val)
{
  factory->GetField(this,field,field_name,ret_val);
}
inline void dcall _dobject::RegistMethod
      (dobject receiver,dMethod *method,dint flag,void *fp,dchararray func_name,dchararray param,dint ret_vt,void *data[])
{
  factory->RegistMethod(this,receiver,method,flag,fp,func_name,param,ret_vt,data);
}

//dobject define macro
#define DECLEAR_DSRE_FUNCTION(func_name) void dcall func_name(dMethod *method,dobject sender,pAutoArg args,dValue *ret_val)
#define DEFINE_DSRE_FUNCTION(cls_name,func_name) void dcall cls_name::func_name(dMethod *method,dobject sender,pAutoArg args,dValue *ret_val)

#ifdef _MSC_VER
#define REGIST_DSRE_METHOD(impl,func,vt) \
    {wchar_t *fname_w=(wchar_t *)(g_RuntimeVars.vm->Alloc((dobject)this,128)); \
    MultiBytesToWides(fname_w,#func"",strlen(#func""));                        \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)this,&(df->func),BASE_CALL,GetFunctionPointer(&impl::func),fname_w,typeid(&impl::func).name(),vt);   \
    df->_cbCount++;}
#else
#define REGIST_DSRE_METHOD(impl,func,vt) \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)this,&(df->func),BASE_CALL,GetFunctionPointer(&impl::func),L""#func"",typeid(&impl::func).name(),vt);   \
    df->_cbCount++;
#endif

#ifdef _MSC_VER
#define REGIST_DSRE_VOID_METHOD(impl,func) \
    {wchar_t *fname_w=(wchar_t *)(g_RuntimeVars.vm->Alloc((dobject)this,128)); \
    MultiBytesToWides(fname_w,#func"",strlen(#func""));                        \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)this,&(df->func),BASE_CALL,GetFunctionPointer(&impl::func),fname_w,typeid(&impl::func).name(),vt_void);   \
    df->_cbCount++;}
#else
#define REGIST_DSRE_VOID_METHOD(impl,func) \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)this,&(df->func),BASE_CALL,GetFunctionPointer(&impl::func),L""#func"",typeid(&impl::func).name(),vt_void);   \
    df->_cbCount++;
#endif

#ifdef _MSC_VER
#define REGIST_DSRE_INST_VOID_METHOD(pThis,inst,func) \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)pThis,&(df->func),BASE_CALL,GetFunctionPointer(&impl::func),L"#func",typeid(&impl::func).name(),vt_void);   \
    df->_cbCount++;
#else
#define REGIST_DSRE_INST_VOID_METHOD(pThis,inst,func) \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)pThis,&(df->func),BASE_CALL,GetFunctionPointer(&impl::func),L""#func"",typeid(&impl::func).name(),vt_void);   \
    df->_cbCount++;
#endif


//popular creater
template<class inst_class,class impl_class,class clone_class>
dobject CreateObjectWithInstImplClone(dFactory *factory,dchararray cls_name,impl_class *&impl,clone_class *&clone,inst_class *local_inst)
{
  dobject dobj=NULL;
  if(local_inst)
  {
    clone=new clone_class();
    clone->inst=(inst_class *)local_inst;
  }else
  {
    clone=NULL;
  }
  impl=(impl_class *)g_RuntimeVars.vm->AllocObject((dobject)g_RuntimeVars.factory,sizeof(impl_class));
  impl->inst=clone;
  
  //make argument list
  dAutoArg args;
  dValue n,ret;
  n=cls_name;
  
  //real arguments:(dchararray name,other params)
  args<<&n;
  impl->_Create(NULL,(dobject)factory,&args,&ret);
  dobj=ret.o.o;//get the result object
  
  if(dobj!=(dobject)impl)//last the oriant class
  {
    factory->env->Invoke(factory,(dobject)impl,(dobject)factory,NULL,0,L"_Release",&args,&ret);
    return NULL;
  }else
  {
    dobj->factory=factory;
    dobj->native_inst_level=1;
    return dobj;
  }
}

#define CreatePopularObject(factory,param_class_name,cls_name,local_inst) \
  cls_name##_impl *impl; \
  cls_name##_clone *clone; \
  cls_name *inst=(cls_name *)local_inst; \
  dobj=CreateObjectWithInstImplClone(factory,param_class_name,impl,clone,inst);

template<class inst_class,class impl_class>
dobject CreateObjectWithInstImplNoClone(dFactory *factory,dchararray cls_name,impl_class *&impl,inst_class *local_inst)
{
  dobject dobj=NULL;
  impl=(impl_class *)g_RuntimeVars.vm->AllocObject((dobject)g_RuntimeVars.factory,sizeof(impl_class));
  impl->inst=local_inst;
  
  //make argument list
  dAutoArg args;
  dValue n,ret;
  n=cls_name;
  
  //real arguments:(dchararray name,other params)
  args<<&n;
  impl->_Create(NULL,(dobject)factory,&args,&ret);
  dobj=ret.o.o;//get the result object
  
  if(dobj!=(dobject)impl)//last the oriant class
  {
    factory->env->Invoke(factory,(dobject)impl,(dobject)factory,NULL,0,L"_Release",&args,&ret);
    return NULL;
  }else
  {
    dobj->factory=factory;
    return dobj;
  }
}

#define CreatePopularObjectNoClone(factory,param_class_name,cls_name,local_inst) \
  cls_name##_impl *impl; \
  cls_name *inst=(cls_name *)local_inst; \
  dobj=CreateObjectWithInstImplNoClone(factory,param_class_name,impl,inst);

#define BEGIN_DSRE_POPULAR_OBJECT(inst_class)                                            \
struct inst_class##_impl                                                                 \
{                                                                                        \
  inst_class* inst;                                                                      \
  NORMAL_DS_OBJECT_HEADER;                                                               \
  NORMAL_DS_OBJECT_FUNC_DATA                                                             \
                                                                                         \
  void RegM(void *fp,const char * func_name,const char *param,dint ret_vt)               \
  {                                                                                      \
    dynamic_functions_t* df_temp=(dynamic_functions_t*)g_RuntimeVars.vm->Alloc((dobject)this,sizeof(dint)+sizeof(dMethod)*(df->_cbCount+2)); \
    memcpy(df_temp,df,sizeof(dint)+sizeof(dMethod)*df->_cbCount);                        \
    g_RuntimeVars.vm->Unalloc((dobject)this,df);                                         \
    df=df_temp;                                                                          \
                                                                                         \
    dobject pThis=(dobject)this;                                                         \
    wchar_t *fname_w=(wchar_t *)(g_RuntimeVars.vm->Alloc((dobject)this,128));            \
    MultiBytesToWides(fname_w,func_name,strlen(func_name));                              \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)this,&(pThis->df->_Method0[df->_cbCount]),BASE_CALL,fp,fname_w,L"",ret_vt);   \
    pThis->df->_Method0[df->_cbCount].t=(dobject)inst;                                   \
    df->_cbCount++;                                                                      \
  }                                                                                      \
                                                                                         \
  DECLEAR_DSRE_FUNCTION(_Create)                                                         \
  {                                                                                      \
    _cbSize=sizeof(*this);                                                               \
                                                                                         \
    df=(dynamic_functions_t*)g_RuntimeVars.vm->Alloc((dobject)this,sizeof(dynamic_functions_t)); \
    memset(df,0,sizeof(dynamic_functions_t));                                            \
                                                                                         \
    REGIST_DSRE_VOID_METHOD(inst_class##_impl,_Create);                                  \
    REGIST_DSRE_VOID_METHOD(inst_class##_impl,_Release);                                 \
    REGIST_DSRE_VOID_METHOD(inst_class##_impl,_Constructor);                             \
    REGIST_DSRE_VOID_METHOD(inst_class##_impl,_Destructor);                              \
                                                                                         \
    data=(Data*)g_RuntimeVars.vm->Alloc((dobject)this,sizeof(Data));                     \
    memset(data,0,sizeof(Data));                                                         \
                                                                                         \
    ret_val->o.o=(dobject)this;                                                          \
  }                                                                                      \
  DECLEAR_DSRE_FUNCTION(_Release)                                                        \
  {                                                                                      \
    g_RuntimeVars.vm->Unalloc((dobject)this,df);                                         \
    g_RuntimeVars.vm->Unalloc((dobject)this,data);                                       \
  }                                                                                      \
                                                                                         \
  void dcall _Constructor(dMethod *method,dobject sender,pAutoArg args,dValue *ret_val)  \
  {                                                                                      \
    if(inst)                                                                             \
    {                                                                                    \

#define DEFINE_POPULAR_METHOD(inst_class,m) this->RegM(GetFunctionPointer(&inst_class::m),#m"",typeid(&inst_class::m).name(),vt_void)

#define END_DSRE_POPULAR_OBJECT()                                                        \
    }                                                                                    \
  }                                                                                      \
                                                                                         \
  void dcall _Destructor(dMethod *method,dobject sender,pAutoArg args,dValue *ret_val)   \
  {                                                                                      \
    if(inst)                                                                             \
    {                                                                                    \
    }                                                                                    \
  }                                                                                      \
}

#define DECLEAR_DSRE_CLASS(inst_class)                                                   \
struct inst_class                                                                        \
{                                                                                        \
  inst_class* inst;                                                                      \
  NORMAL_DS_OBJECT_HEADER;                                                               \
  NORMAL_DS_OBJECT_FUNC_DATA;                                                            \
                                                                                         \
  void RegM(void *fp,const char * func_name,const char *param,dint ret_vt)               \
  {                                                                                      \
    dynamic_functions_t* df_temp=(dynamic_functions_t*)g_RuntimeVars.vm->Alloc((dobject)this,sizeof(dint)+sizeof(dMethod)*(df->_cbCount+2)); \
    memcpy(df_temp,df,sizeof(dint)+sizeof(dMethod)*df->_cbCount);                        \
    g_RuntimeVars.vm->Unalloc((dobject)this,df);                                         \
    df=df_temp;                                                                          \
                                                                                         \
    dobject pThis=(dobject)this;                                                         \
    wchar_t *fname_w=(wchar_t *)(g_RuntimeVars.vm->Alloc((dobject)this,128));            \
    MultiBytesToWides(fname_w,func_name,strlen(func_name));                              \
    g_RuntimeVars.factory->RegistMethod(NULL,(dobject)this,&(pThis->df->_Method0[df->_cbCount]),BASE_CALL,fp,fname_w,L"",ret_vt);   \
    pThis->df->_Method0[df->_cbCount].t=(dobject)inst;                                   \
    df->_cbCount++;                                                                      \
  }                                                                                      \
                                                                                         \
  void RegF(const char * field_name,dValuePointerWrapper *f)                             \
  {                                                                                      \
    dint size=(data->_cbCount+7)*sizeof(dField)+sizeof(dint);                            \
    Data *d_temp=(Data *)g_RuntimeVars.vm->Alloc((dobject)this,size);                    \
    memcpy(d_temp,data,sizeof(dint)+sizeof(dField)*data->_cbCount);                      \
    g_RuntimeVars.vm->Unalloc((dobject)this,data);                                       \
    data=d_temp;                                                                         \
                                                                                         \
    dobject pThis=(dobject)this;                                                         \
    wchar_t *fname_w=(wchar_t *)(g_RuntimeVars.vm->Alloc((dobject)this,128));            \
    MultiBytesToWides(fname_w,field_name,strlen(field_name));                            \
    dField *field_p=&data->_Field0[data->_cbCount];                                      \
    f->obj=pThis;                                                                        \
    f->field_index=data->_cbCount;                                                       \
    g_RuntimeVars.factory->RegistField((dobject)this,field_p,NULL,NULL,fname_w,NULL,vt_unknown); \
    data->_cbCount++;                                                                    \
  }                                                                                      \
                                                                                         \
  DECLEAR_DSRE_FUNCTION(_Create)                                                         \
  {                                                                                      \
    _cbSize=sizeof(*this);                                                               \
                                                                                         \
    df=(dynamic_functions_t*)g_RuntimeVars.vm->Alloc((dobject)this,sizeof(dynamic_functions_t)); \
    memset(df,0,sizeof(dynamic_functions_t));                                            \
                                                                                         \
    REGIST_DSRE_VOID_METHOD(inst_class,_Create);                                         \
    REGIST_DSRE_VOID_METHOD(inst_class,_Release);                                        \
    REGIST_DSRE_VOID_METHOD(inst_class,_Constructor);                                    \
    REGIST_DSRE_VOID_METHOD(inst_class,_Destructor);                                     \
                                                                                         \
    data=(Data*)g_RuntimeVars.vm->Alloc((dobject)this,sizeof(Data));                     \
    memset(data,0,sizeof(Data));                                                         \
                                                                                         \
    ret_val->o.o=(dobject)this;                                                          \
  }                                                                                      \
  DECLEAR_DSRE_FUNCTION(_Release)                                                        \
  {                                                                                      \
    g_RuntimeVars.vm->Unalloc((dobject)this,df);                                         \
    g_RuntimeVars.vm->Unalloc((dobject)this,data);                                       \
  }                                                                                      \
                                                                                         \
  DECLEAR_DSRE_FUNCTION(_Constructor)                                                    \
  {                                                                                      \
    inst=this;                                                                           \
    _DoConstructor(method,sender,args,ret_val);                                          \
  }                                                                                      \
                                                                                         \
  DECLEAR_DSRE_FUNCTION(_Destructor)                                                     \
  {                                                                                      \
    if(inst)                                                                             \
    {                                                                                    \
      _DoDestructor(method,sender,args,ret_val);                                         \
    }                                                                                    \
  }                                                                                      \

#define END_DECLEAR_DSRE_CLASS \
}

#define DECLEAR_DSRE_CONSTRUCTOR(inst_class) \
  DECLEAR_DSRE_FUNCTION(_DoConstructor)

#define DECLEAR_DSRE_DISTRUCTOR(inst_class) \
  DECLEAR_DSRE_FUNCTION(_DoDestructor)

#define DEFINE_DSRE_CONSTRUCTOR(inst_class) \
  DEFINE_DSRE_FUNCTION(inst_class,_DoConstructor)

#define DEFINE_DSRE_DISTRUCTOR(inst_class) \
  DEFINE_DSRE_FUNCTION(inst_class,_DoDestructor)

#define PUBLISH_DSRE_FUNCTION(inst_class,m) \
  this->RegM(GetFunctionPointer(&inst_class::m),#m"",typeid(&inst_class::m).name(),vt_void)
#define PUBLISH_DSRE_FIELD(f) \
  this->RegF(#f"",&f)

class dobject_ptr
{
public:
  dobject o;
  dobject owner;
public:
  dobject_ptr():o(NULL),owner(NULL){}
  dobject_ptr(const dobject dobj):o(NULL),owner(NULL){_Attach(dobj);}
  dobject_ptr(const dobject dobj,const dobject owner_obj):o(NULL),owner(NULL){_Attach(dobj,owner_obj);}
  ~dobject_ptr(){if(o){o->_RefCount--;}_Detach();}
public:
  dobject_ptr &operator=(const dobject_ptr &rhs){_Detach();_Attach(rhs.o,rhs.owner);return *this;}
  dobject_ptr &operator=(const dobject dobj){_Detach();_Attach(dobj);return *this;}
private:
  void _Attach(dobject dobj){o=dobj;if(o)o->_RefCount++;}
  void _Attach(dobject dobj,dobject owner_obj){o=dobj;owner=owner_obj;if(o)o->_RefCount++;}
  void _Detach(){if(o && o->_RefCount==0)g_RuntimeVars.vm->UnallocObject(owner,o);o=NULL;}
};

#pragma pack()
//published declear]- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

#define DSRE_CURRENT_VER 2298 //2.0 build 298

#endif //__DNI_H__

