import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.lang.reflect.*;

public class LBridge
{
  static
  {
    System.loadLibrary("Java_Bridge");
  }
  public native static void HintJEnv();
  public native static void SetDefaultVM(int vm,int env,int factory);
  public native static void SetNotJavaClass(int b);

  public native static void SetMethodCount(int imp,int count);

  public native static void GetAllMethod(int imp,String methodName,String methodString,String retType);
  public native static void SetAllConstructor(int imp,String paramString);

  public native static void SetDataCount(int imp,int count);
  public native static void SetAllData(int imp,String dataName,String dataType);

  public native static void MouseListenerReady(int imp);
  public native static void MouseMotionListenerReady(int imp);
  public native static void WindowListenerReady(int imp);
  public native static void ActionListenerReady(int imp);
  public native static void KeyListenerReady(int imp);
  public native static void FocusListenerReady(int imp);
  public native static void ComponentListenerReady(int imp);
  public native static void TextListenerReady(int imp);
  public native static void JTextListenerReady(int imp);

  public native static void NoParamEvent(int imp,String event_name);
  public native static void TowParamEvent(int imp,String event_name,int x,int y);

  static LBridge Bridge;//global bridge object. from Java_Bridge.dll
  private Object[] Objects;
  private int ObjectCount;
  
  public LBridge()
  {
    Bridge=this;
    Objects=new Object[20];
    Objects[0]=this;
    ObjectCount=1;
    
    if(dVM.dvm!=null)//vm have exists
    {
    }
  }
  
  public void hintJEnv()
  {
    HintJEnv();
  }

  public Object getObject(int index)
  {
    if(index<ObjectCount)
      return Objects[index];
    return null;
  }
  public int setObject(Object obj)
  {
    int i;
    //find
    for(i=0;i<ObjectCount;i++)
    {
      if(Objects[i]==obj)
        return i;
    }

    //not found
    if(ObjectCount%20==0)
    {
      Object[] objs=new Object[ObjectCount+20];
      for(i=0;i<ObjectCount;i++)
      {
        objs[i]=Objects[i];
      }
      Objects=objs;
    }
    Objects[ObjectCount]=obj;
    return ObjectCount++;
  }

  public void setDefaultVM(int vm,int env,int factory)
  {
    SetDefaultVM(vm,env,factory);

    if(dVM.dvm==null)
    {
      dVM.dvm=new dVM();
      dVM.dvm.setDefaultVM(vm,env,factory);
    }
  }

  public void recvObjectFieldCount(int imp,Object obj)
  {
    impl=imp;
    Class myClass=obj.getClass();

    int i;
    Constructor[] c=myClass.getConstructors();
    Method[] m=myClass.getMethods();
    Field[] f=myClass.getDeclaredFields();

    SetMethodCount(impl,c.length+m.length);
    SetDataCount(impl,f.length);
  }
  public void recvObjectFields(int imp,Object obj)
  {
    impl=imp;
    Class myClass=obj.getClass();

    int i;
    Constructor[] c=myClass.getConstructors();
    Method[] m=myClass.getMethods();
    Field[] f=myClass.getDeclaredFields();

    for(i=0; i<c.length;i++){
        SetAllConstructor(impl,c[i].toString());
    }
    for(i=0; i<m.length;i++){
        GetAllMethod(impl,m[i].getName(),m[i].toString(),m[i].getReturnType().toString());
    }
    for(i=0; i<f.length;i++){
        SetAllData(impl,f[i].getName(),f[i].toString());
    }
  }
  public void setEvnets(int imp,Object obj)
  {
    impl=imp;

    //add mouse listener
    try{
      Component c=(Component)obj;
      c.addMouseListener(new ML(this,imp));
      MouseListenerReady(imp);
    }catch(ClassCastException e){}

    //add window listener
    try{
      Window w=(Window)obj;
      w.addWindowListener(new WL(this,imp));
      WindowListenerReady(imp);
    }catch(ClassCastException e){}

    //find one ActionListener
    //as a Button ?
    try{
      Button b=(Button)obj;
      b.addActionListener(new AL(this,imp));
      ActionListenerReady(imp);
    }catch(ClassCastException e){}
    try{
      JButton b=(JButton)obj;
      b.addActionListener(new AL(this,imp));
      ActionListenerReady(imp);
    }catch(ClassCastException e){}
    //as a Checkbox ?
    try{
      Checkbox b=(Checkbox)obj;
      b.addItemListener(new IL(this,imp));
      ActionListenerReady(imp);
    }catch(ClassCastException e){}
    //as a Choice ?
    try{
      Choice b=(Choice)obj;
      b.addItemListener(new IL(this,imp));
      ActionListenerReady(imp);
    }catch(ClassCastException e){}
    //as a List ?
    try{
      List b=(List)obj;
      b.addActionListener(new AL(this,imp));
      b.addItemListener(new IL(this,imp));
      ActionListenerReady(imp);
    }catch(ClassCastException e){}

    //add motion listener
    try{
      Window w=(Window)obj;
      w.addMouseMotionListener(new MM(this,imp));
      MouseMotionListenerReady(imp);
    }catch(ClassCastException e){}

    //add key listener
    try{
      Window w=(Window)obj;
      w.addKeyListener(new KL(this,imp));
      KeyListenerReady(imp);
    }catch(ClassCastException e){}

    //add focus listener
    try{
      Window w=(Window)obj;
      w.addFocusListener(new FL(this,imp));
      FocusListenerReady(imp);
    }catch(ClassCastException e){}
    //add component listener
    try{
      Window w=(Window)obj;
      w.addComponentListener(new CL(this,imp));
      ComponentListenerReady(imp);
    }catch(ClassCastException e){}

    //add change listener
    try{
      TextComponent t=(TextComponent)obj;
      t.addTextListener(new TL(this,imp));
      TextListenerReady(imp);
    }catch(ClassCastException e){}
    //add change listener
    try{
      JTextComponent t=(JTextComponent)obj;
      t.addCaretListener(new CAL(this,imp));
      t.addKeyListener(new KL(this,imp));
      JTextListenerReady(imp);
    }catch(ClassCastException e){}
  }
  public void noParamEvent(int imp,String event_name)
  {
    NoParamEvent(imp,event_name);
  }
  public void towParamEvent(int imp,String event_name,int x,int y)
  {
    TowParamEvent(imp,event_name,x,y);
  }

  public int impl;
}

class ML implements MouseListener{
  private LBridge bridge;
  private int impl;
  public ML(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void mouseExited(MouseEvent me){
    bridge.noParamEvent(impl,"mouseExited");
  }
  public void mouseEntered(MouseEvent me){
    bridge.noParamEvent(impl,"mouseEntered");
  }
  public void mouseReleased(MouseEvent me){
    bridge.noParamEvent(impl,"mouseReleased");
  }
  public void mousePressed(MouseEvent me){
    bridge.noParamEvent(impl,"mousePressed");
  }
  public void mouseClicked(MouseEvent me){
    bridge.noParamEvent(impl,"mouseClicked");
  }
}
class MM implements MouseMotionListener{
  private LBridge bridge;
  private int impl;
  public MM(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void mouseMoved(MouseEvent me){
    bridge.towParamEvent(impl,"mouseMoved",me.getX(),me.getY());
  }
  public void mouseDragged(MouseEvent me){
    bridge.towParamEvent(impl,"mouseDragged",me.getX(),me.getY());
  }
}

class WL implements WindowListener{
  private LBridge bridge;
  private int impl;
  public WL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void windowDeactivated(WindowEvent we){
    bridge.noParamEvent(impl,"windowDeactivated");
  }
  public void windowActivated(WindowEvent we){
    bridge.noParamEvent(impl,"windowActivated");
  }
  public void windowDeiconified(WindowEvent we){
    bridge.noParamEvent(impl,"windowDeiconified");
  }
  public void windowIconified(WindowEvent we){
    bridge.noParamEvent(impl,"windowIconified");
  }
  public void windowClosed(WindowEvent we){
    bridge.noParamEvent(impl,"windowClosed");
  }
  public void windowClosing(WindowEvent we){
    bridge.noParamEvent(impl,"windowClosing");
  }
  public void windowOpened(WindowEvent we){
    bridge.noParamEvent(impl,"windowOpened");
  }
}

class AL implements ActionListener{
  private LBridge bridge;
  private int impl;
  public AL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void actionPerformed(ActionEvent ae){
    bridge.noParamEvent(impl,"actionPerformed");
  }
}
class IL implements ItemListener{
  private LBridge bridge;
  private int impl;
  public IL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void itemStateChanged(ItemEvent ie){
    bridge.noParamEvent(impl,"itemStateChanged");
  }
}

class KL implements KeyListener{
  private LBridge bridge;
  private int impl;
  public KL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void keyReleased(KeyEvent ke){
    bridge.towParamEvent(impl,"keyReleased",ke.getKeyCode(),0);
  }
  public void keyPressed(KeyEvent ke){
    bridge.towParamEvent(impl,"keyPressed",ke.getKeyCode(),0);
  }
  public void keyTyped(KeyEvent ke){
    bridge.towParamEvent(impl,"keyTyped",ke.getKeyCode(),0);
  }
}

class FL implements FocusListener{
  private LBridge bridge;
  private int impl;
  public FL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void focusLost(FocusEvent fe){
    bridge.noParamEvent(impl,"focusLost");
  }
  public void focusGained(FocusEvent fe){
    bridge.noParamEvent(impl,"focusGained");
  }
}

class CL implements ComponentListener{
  private LBridge bridge;
  private int impl;
  public CL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void componentHidden(ComponentEvent ce){
    bridge.noParamEvent(impl,"componentHidden");
  }
  public void componentShown(ComponentEvent ce){
    bridge.noParamEvent(impl,"componentShown");
  }
  public void componentMoved(ComponentEvent ce){
    bridge.noParamEvent(impl,"componentMoved");
  }
  public void componentResized(ComponentEvent ce){
    bridge.noParamEvent(impl,"componentResized");
  }
}
class TL implements TextListener{
  private LBridge bridge;
  private int impl;
  public TL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void textValueChanged(TextEvent ce){
    bridge.noParamEvent(impl,"textValueChanged");
  }
}

class CAL implements CaretListener{
  private LBridge bridge;
  private int impl;
  public CAL(LBridge b,int imp){
    bridge=b;
    impl=imp;
  }
  public void caretUpdate(CaretEvent e){
    bridge.noParamEvent(impl,"caretUpdate");
  }
}
